/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("s8", *type, 2)) {
		*type += 2;
		return TYPE_S8;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->srcs[instr->srcs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 0; i < instr->srcs_count - 1; i++) {
		instr->srcs[i+1] = instr->srcs[i];
	}
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 339 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_A_PVTMEM = 19,                /* T_A_PVTMEM  */
  YYSYMBOL_T_A_EARLYPREAMBLE = 20,         /* T_A_EARLYPREAMBLE  */
  YYSYMBOL_T_ABSNEG = 21,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 22,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 23,                     /* T_ABS  */
  YYSYMBOL_T_R = 24,                       /* T_R  */
  YYSYMBOL_T_LAST = 25,                    /* T_LAST  */
  YYSYMBOL_T_HR = 26,                      /* T_HR  */
  YYSYMBOL_T_HC = 27,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 28,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 29,            /* T_POS_INFINITY  */
  YYSYMBOL_T_NEG_INFINITY = 30,            /* T_NEG_INFINITY  */
  YYSYMBOL_T_EI = 31,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 32,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 33,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 34,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 35,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 36,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 37,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 38,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 39,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 40,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 41,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 42,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 43,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 44,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 45,                      /* T_SY  */
  YYSYMBOL_T_SS = 46,                      /* T_SS  */
  YYSYMBOL_T_JP = 47,                      /* T_JP  */
  YYSYMBOL_T_SAT = 48,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 49,                     /* T_RPT  */
  YYSYMBOL_T_UL = 50,                      /* T_UL  */
  YYSYMBOL_T_NOP = 51,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 52,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 53,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 54,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 55,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 56,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 57,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 58,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 59,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 60,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 61,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 62,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 63,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 64,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 65,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 66,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 67,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 68,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 69,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 70,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 71,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 72,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 73,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 74,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETLAST = 75,              /* T_OP_GETLAST  */
  YYSYMBOL_T_OP_GETONE = 76,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 77,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 78,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 79,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 80,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 81,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 82,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 83,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 84,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 85,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 86,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 87,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_SWZ = 88,                  /* T_OP_SWZ  */
  YYSYMBOL_T_OP_GAT = 89,                  /* T_OP_GAT  */
  YYSYMBOL_T_OP_SCT = 90,                  /* T_OP_SCT  */
  YYSYMBOL_T_OP_ADD_F = 91,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 92,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 93,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 94,                /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 95,               /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 96,               /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 97,             /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 98,               /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 99,              /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 100,              /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 101,             /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 102,             /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 103,             /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 104,               /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 105,               /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 106,               /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 107,               /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 108,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 109,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 110,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 111,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 112,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 113,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 114,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 115,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 116,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 117,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 118,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 119,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 120,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 121,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 122,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 123,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 124,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 125,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 126,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 127,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 128,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 129,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 130,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_FLAT_B = 131,              /* T_OP_FLAT_B  */
  YYSYMBOL_T_OP_MGEN_B = 132,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 133,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 134,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 135,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 136,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 137,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 138,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 139,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 140,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 141,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 142,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 143,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 144,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 145,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 146,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 147,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 148,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 149,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 150,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 151,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 152,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 153,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_SHRM = 154,                /* T_OP_SHRM  */
  YYSYMBOL_T_OP_SHLM = 155,                /* T_OP_SHLM  */
  YYSYMBOL_T_OP_SHRG = 156,                /* T_OP_SHRG  */
  YYSYMBOL_T_OP_SHLG = 157,                /* T_OP_SHLG  */
  YYSYMBOL_T_OP_ANDG = 158,                /* T_OP_ANDG  */
  YYSYMBOL_T_OP_DP2ACC = 159,              /* T_OP_DP2ACC  */
  YYSYMBOL_T_OP_DP4ACC = 160,              /* T_OP_DP4ACC  */
  YYSYMBOL_T_OP_WMM = 161,                 /* T_OP_WMM  */
  YYSYMBOL_T_OP_WMM_ACCU = 162,            /* T_OP_WMM_ACCU  */
  YYSYMBOL_T_OP_RCP = 163,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 164,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 165,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 166,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 167,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 168,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 169,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 170,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 171,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 172,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 173,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 174,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 175,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 176,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 177,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 178,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 179,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 180,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 181,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 182,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 183,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 184,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 185,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 186,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 187,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 188,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 189,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 190,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 191,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 192,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 193,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 194,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 195,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 196,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 197,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 198,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 199,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 200,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_BRCST_A = 201,             /* T_OP_BRCST_A  */
  YYSYMBOL_T_OP_QSHUFFLE_BRCST = 202,      /* T_OP_QSHUFFLE_BRCST  */
  YYSYMBOL_T_OP_QSHUFFLE_H = 203,          /* T_OP_QSHUFFLE_H  */
  YYSYMBOL_T_OP_QSHUFFLE_V = 204,          /* T_OP_QSHUFFLE_V  */
  YYSYMBOL_T_OP_QSHUFFLE_DIAG = 205,       /* T_OP_QSHUFFLE_DIAG  */
  YYSYMBOL_T_OP_TCINV = 206,               /* T_OP_TCINV  */
  YYSYMBOL_T_OP_LDG = 207,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDG_A = 208,               /* T_OP_LDG_A  */
  YYSYMBOL_T_OP_LDL = 209,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 210,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 211,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STG_A = 212,               /* T_OP_STG_A  */
  YYSYMBOL_T_OP_STL = 213,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 214,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 215,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 216,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 217,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 218,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 219,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 220,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 221,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 222,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 223,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 224,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 225,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 226,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 227,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 228,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 229,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 230,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 231,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 232,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 233,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 234,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 235,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 236,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 237,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 238,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 239,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 240,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 241,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 242,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 243,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 244,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 245,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 246,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 247,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_ATOMIC_S_ADD = 248,        /* T_OP_ATOMIC_S_ADD  */
  YYSYMBOL_T_OP_ATOMIC_S_SUB = 249,        /* T_OP_ATOMIC_S_SUB  */
  YYSYMBOL_T_OP_ATOMIC_S_XCHG = 250,       /* T_OP_ATOMIC_S_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_INC = 251,        /* T_OP_ATOMIC_S_INC  */
  YYSYMBOL_T_OP_ATOMIC_S_DEC = 252,        /* T_OP_ATOMIC_S_DEC  */
  YYSYMBOL_T_OP_ATOMIC_S_CMPXCHG = 253,    /* T_OP_ATOMIC_S_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_MIN = 254,        /* T_OP_ATOMIC_S_MIN  */
  YYSYMBOL_T_OP_ATOMIC_S_MAX = 255,        /* T_OP_ATOMIC_S_MAX  */
  YYSYMBOL_T_OP_ATOMIC_S_AND = 256,        /* T_OP_ATOMIC_S_AND  */
  YYSYMBOL_T_OP_ATOMIC_S_OR = 257,         /* T_OP_ATOMIC_S_OR  */
  YYSYMBOL_T_OP_ATOMIC_S_XOR = 258,        /* T_OP_ATOMIC_S_XOR  */
  YYSYMBOL_T_OP_ATOMIC_G_ADD = 259,        /* T_OP_ATOMIC_G_ADD  */
  YYSYMBOL_T_OP_ATOMIC_G_SUB = 260,        /* T_OP_ATOMIC_G_SUB  */
  YYSYMBOL_T_OP_ATOMIC_G_XCHG = 261,       /* T_OP_ATOMIC_G_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_INC = 262,        /* T_OP_ATOMIC_G_INC  */
  YYSYMBOL_T_OP_ATOMIC_G_DEC = 263,        /* T_OP_ATOMIC_G_DEC  */
  YYSYMBOL_T_OP_ATOMIC_G_CMPXCHG = 264,    /* T_OP_ATOMIC_G_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_MIN = 265,        /* T_OP_ATOMIC_G_MIN  */
  YYSYMBOL_T_OP_ATOMIC_G_MAX = 266,        /* T_OP_ATOMIC_G_MAX  */
  YYSYMBOL_T_OP_ATOMIC_G_AND = 267,        /* T_OP_ATOMIC_G_AND  */
  YYSYMBOL_T_OP_ATOMIC_G_OR = 268,         /* T_OP_ATOMIC_G_OR  */
  YYSYMBOL_T_OP_ATOMIC_G_XOR = 269,        /* T_OP_ATOMIC_G_XOR  */
  YYSYMBOL_T_OP_LDGB = 270,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 271,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 272,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 273,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 274,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 275,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 276,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_GETFIBERID = 277,          /* T_OP_GETFIBERID  */
  YYSYMBOL_T_OP_STC = 278,                 /* T_OP_STC  */
  YYSYMBOL_T_OP_STSC = 279,                /* T_OP_STSC  */
  YYSYMBOL_T_OP_BAR = 280,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 281,               /* T_OP_FENCE  */
  YYSYMBOL_T_OP_SLEEP = 282,               /* T_OP_SLEEP  */
  YYSYMBOL_T_OP_ICINV = 283,               /* T_OP_ICINV  */
  YYSYMBOL_T_OP_DCCLN = 284,               /* T_OP_DCCLN  */
  YYSYMBOL_T_OP_DCINV = 285,               /* T_OP_DCINV  */
  YYSYMBOL_T_OP_DCFLU = 286,               /* T_OP_DCFLU  */
  YYSYMBOL_T_OP_LOCK = 287,                /* T_OP_LOCK  */
  YYSYMBOL_T_OP_UNLOCK = 288,              /* T_OP_UNLOCK  */
  YYSYMBOL_T_OP_ALIAS = 289,               /* T_OP_ALIAS  */
  YYSYMBOL_T_RAW = 290,                    /* T_RAW  */
  YYSYMBOL_T_TYPE_F16 = 291,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 292,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 293,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 294,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 295,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 296,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 297,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_S8 = 298,                /* T_TYPE_S8  */
  YYSYMBOL_T_UNTYPED = 299,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 300,                  /* T_TYPED  */
  YYSYMBOL_T_MIXED = 301,                  /* T_MIXED  */
  YYSYMBOL_T_UNSIGNED = 302,               /* T_UNSIGNED  */
  YYSYMBOL_T_LOW = 303,                    /* T_LOW  */
  YYSYMBOL_T_HIGH = 304,                   /* T_HIGH  */
  YYSYMBOL_T_1D = 305,                     /* T_1D  */
  YYSYMBOL_T_2D = 306,                     /* T_2D  */
  YYSYMBOL_T_3D = 307,                     /* T_3D  */
  YYSYMBOL_T_4D = 308,                     /* T_4D  */
  YYSYMBOL_T_LT = 309,                     /* T_LT  */
  YYSYMBOL_T_LE = 310,                     /* T_LE  */
  YYSYMBOL_T_GT = 311,                     /* T_GT  */
  YYSYMBOL_T_GE = 312,                     /* T_GE  */
  YYSYMBOL_T_EQ = 313,                     /* T_EQ  */
  YYSYMBOL_T_NE = 314,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 315,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 316,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 317,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 318,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 319,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 320,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 321,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 322,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 323,                    /* T_NAN  */
  YYSYMBOL_T_INF = 324,                    /* T_INF  */
  YYSYMBOL_T_A0 = 325,                     /* T_A0  */
  YYSYMBOL_T_A1 = 326,                     /* T_A1  */
  YYSYMBOL_T_P0 = 327,                     /* T_P0  */
  YYSYMBOL_T_W = 328,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 329,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_T_INSTR_TYPE = 330,             /* T_INSTR_TYPE  */
  YYSYMBOL_T_MOD_TEX = 331,                /* T_MOD_TEX  */
  YYSYMBOL_T_MOD_MEM = 332,                /* T_MOD_MEM  */
  YYSYMBOL_T_MOD_RT = 333,                 /* T_MOD_RT  */
  YYSYMBOL_334_ = 334,                     /* '-'  */
  YYSYMBOL_335_ = 335,                     /* ','  */
  YYSYMBOL_336_ = 336,                     /* '('  */
  YYSYMBOL_337_ = 337,                     /* ')'  */
  YYSYMBOL_338_ = 338,                     /* '='  */
  YYSYMBOL_339_ = 339,                     /* ':'  */
  YYSYMBOL_340_ = 340,                     /* '!'  */
  YYSYMBOL_341_ = 341,                     /* '#'  */
  YYSYMBOL_342_ = 342,                     /* '.'  */
  YYSYMBOL_343_a_ = 343,                   /* 'a'  */
  YYSYMBOL_344_o_ = 344,                   /* 'o'  */
  YYSYMBOL_345_p_ = 345,                   /* 'p'  */
  YYSYMBOL_346_s_ = 346,                   /* 's'  */
  YYSYMBOL_347_ = 347,                     /* '+'  */
  YYSYMBOL_348_ = 348,                     /* '<'  */
  YYSYMBOL_349_g_ = 349,                   /* 'g'  */
  YYSYMBOL_350_ = 350,                     /* '['  */
  YYSYMBOL_351_ = 351,                     /* ']'  */
  YYSYMBOL_352_l_ = 352,                   /* 'l'  */
  YYSYMBOL_353_k_ = 353,                   /* 'k'  */
  YYSYMBOL_354_c_ = 354,                   /* 'c'  */
  YYSYMBOL_355_w_ = 355,                   /* 'w'  */
  YYSYMBOL_356_r_ = 356,                   /* 'r'  */
  YYSYMBOL_357_ = 357,                     /* '>'  */
  YYSYMBOL_358_h_ = 358,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 359,                 /* $accept  */
  YYSYMBOL_shader = 360,                   /* shader  */
  YYSYMBOL_361_1 = 361,                    /* $@1  */
  YYSYMBOL_headers = 362,                  /* headers  */
  YYSYMBOL_header = 363,                   /* header  */
  YYSYMBOL_const_val = 364,                /* const_val  */
  YYSYMBOL_localsize_header = 365,         /* localsize_header  */
  YYSYMBOL_const_header = 366,             /* const_header  */
  YYSYMBOL_buf_header_addr_reg = 367,      /* buf_header_addr_reg  */
  YYSYMBOL_buf_header = 368,               /* buf_header  */
  YYSYMBOL_369_2 = 369,                    /* $@2  */
  YYSYMBOL_invocationid_header = 370,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 371,              /* wgid_header  */
  YYSYMBOL_numwg_header = 372,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 373,       /* branchstack_header  */
  YYSYMBOL_pvtmem_header = 374,            /* pvtmem_header  */
  YYSYMBOL_earlypreamble_header = 375,     /* earlypreamble_header  */
  YYSYMBOL_in_header = 376,                /* in_header  */
  YYSYMBOL_out_header = 377,               /* out_header  */
  YYSYMBOL_tex_header = 378,               /* tex_header  */
  YYSYMBOL_iflag = 379,                    /* iflag  */
  YYSYMBOL_iflags = 380,                   /* iflags  */
  YYSYMBOL_instrs = 381,                   /* instrs  */
  YYSYMBOL_instr = 382,                    /* instr  */
  YYSYMBOL_label = 383,                    /* label  */
  YYSYMBOL_cat0_src1 = 384,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 385,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 386,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 387,               /* cat0_instr  */
  YYSYMBOL_388_3 = 388,                    /* $@3  */
  YYSYMBOL_389_4 = 389,                    /* $@4  */
  YYSYMBOL_390_5 = 390,                    /* $@5  */
  YYSYMBOL_391_6 = 391,                    /* $@6  */
  YYSYMBOL_392_7 = 392,                    /* $@7  */
  YYSYMBOL_393_8 = 393,                    /* $@8  */
  YYSYMBOL_394_9 = 394,                    /* $@9  */
  YYSYMBOL_395_10 = 395,                   /* $@10  */
  YYSYMBOL_396_11 = 396,                   /* $@11  */
  YYSYMBOL_397_12 = 397,                   /* $@12  */
  YYSYMBOL_398_13 = 398,                   /* $@13  */
  YYSYMBOL_399_14 = 399,                   /* $@14  */
  YYSYMBOL_400_15 = 400,                   /* $@15  */
  YYSYMBOL_401_16 = 401,                   /* $@16  */
  YYSYMBOL_402_17 = 402,                   /* $@17  */
  YYSYMBOL_403_18 = 403,                   /* $@18  */
  YYSYMBOL_cat1_opc = 404,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 405,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 406,              /* cat1_movmsk  */
  YYSYMBOL_407_19 = 407,                   /* $@19  */
  YYSYMBOL_cat1_mova1 = 408,               /* cat1_mova1  */
  YYSYMBOL_409_20 = 409,                   /* $@20  */
  YYSYMBOL_cat1_mova = 410,                /* cat1_mova  */
  YYSYMBOL_411_21 = 411,                   /* $@21  */
  YYSYMBOL_cat1_swz = 412,                 /* cat1_swz  */
  YYSYMBOL_413_22 = 413,                   /* $@22  */
  YYSYMBOL_cat1_gat = 414,                 /* cat1_gat  */
  YYSYMBOL_415_23 = 415,                   /* $@23  */
  YYSYMBOL_cat1_sct = 416,                 /* cat1_sct  */
  YYSYMBOL_417_24 = 417,                   /* $@24  */
  YYSYMBOL_cat1_instr = 418,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 419,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 420,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 421,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 422,                     /* cond  */
  YYSYMBOL_cat2_instr = 423,               /* cat2_instr  */
  YYSYMBOL_cat3_dp_signedness = 424,       /* cat3_dp_signedness  */
  YYSYMBOL_cat3_dp_pack = 425,             /* cat3_dp_pack  */
  YYSYMBOL_cat3_opc = 426,                 /* cat3_opc  */
  YYSYMBOL_cat3_imm_reg_opc = 427,         /* cat3_imm_reg_opc  */
  YYSYMBOL_cat3_wmm = 428,                 /* cat3_wmm  */
  YYSYMBOL_cat3_dp = 429,                  /* cat3_dp  */
  YYSYMBOL_cat3_instr = 430,               /* cat3_instr  */
  YYSYMBOL_cat4_opc = 431,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 432,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 433,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc = 434,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 435,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 436,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 437,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 438,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 439,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 440,                  /* cat5_a1  */
  YYSYMBOL_cat5_instr = 441,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 442,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 443,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 444,                /* cat6_type  */
  YYSYMBOL_cat6_imm_offset = 445,          /* cat6_imm_offset  */
  YYSYMBOL_cat6_offset = 446,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 447,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 448,               /* cat6_immed  */
  YYSYMBOL_cat6_a6xx_global_address_pt3 = 449, /* cat6_a6xx_global_address_pt3  */
  YYSYMBOL_cat6_a6xx_global_address_pt2 = 450, /* cat6_a6xx_global_address_pt2  */
  YYSYMBOL_cat6_a6xx_global_address = 451, /* cat6_a6xx_global_address  */
  YYSYMBOL_cat6_load = 452,                /* cat6_load  */
  YYSYMBOL_453_25 = 453,                   /* $@25  */
  YYSYMBOL_454_26 = 454,                   /* $@26  */
  YYSYMBOL_455_27 = 455,                   /* $@27  */
  YYSYMBOL_456_28 = 456,                   /* $@28  */
  YYSYMBOL_457_29 = 457,                   /* $@29  */
  YYSYMBOL_458_30 = 458,                   /* $@30  */
  YYSYMBOL_459_31 = 459,                   /* $@31  */
  YYSYMBOL_cat6_store = 460,               /* cat6_store  */
  YYSYMBOL_461_32 = 461,                   /* $@32  */
  YYSYMBOL_462_33 = 462,                   /* $@33  */
  YYSYMBOL_463_34 = 463,                   /* $@34  */
  YYSYMBOL_464_35 = 464,                   /* $@35  */
  YYSYMBOL_465_36 = 465,                   /* $@36  */
  YYSYMBOL_cat6_loadib = 466,              /* cat6_loadib  */
  YYSYMBOL_467_37 = 467,                   /* $@37  */
  YYSYMBOL_cat6_storeib = 468,             /* cat6_storeib  */
  YYSYMBOL_469_38 = 469,                   /* $@38  */
  YYSYMBOL_cat6_prefetch = 470,            /* cat6_prefetch  */
  YYSYMBOL_471_39 = 471,                   /* $@39  */
  YYSYMBOL_cat6_atomic_opc = 472,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_opc = 473,     /* cat6_a3xx_atomic_opc  */
  YYSYMBOL_cat6_a6xx_atomic_opc = 474,     /* cat6_a6xx_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_s = 475,       /* cat6_a3xx_atomic_s  */
  YYSYMBOL_cat6_a6xx_atomic_g = 476,       /* cat6_a6xx_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 477,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 478,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 479,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 480,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 481,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 482,                 /* cat6_ibo  */
  YYSYMBOL_483_40 = 483,                   /* $@40  */
  YYSYMBOL_cat6_id_opc = 484,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 485,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 486,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 487,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 488,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 489, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 490, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src_dst = 491, /* cat6_bindless_ibo_opc_2src_dst  */
  YYSYMBOL_cat6_bindless_ibo = 492,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 493,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc_middle = 494, /* cat6_bindless_ldc_middle  */
  YYSYMBOL_cat6_bindless_ldc = 495,        /* cat6_bindless_ldc  */
  YYSYMBOL_stc_dst = 496,                  /* stc_dst  */
  YYSYMBOL_cat6_stc = 497,                 /* cat6_stc  */
  YYSYMBOL_498_41 = 498,                   /* $@41  */
  YYSYMBOL_499_42 = 499,                   /* $@42  */
  YYSYMBOL_cat6_todo = 500,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 501,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 502,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 503,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 504,             /* cat7_barrier  */
  YYSYMBOL_505_43 = 505,                   /* $@43  */
  YYSYMBOL_506_44 = 506,                   /* $@44  */
  YYSYMBOL_cat7_data_cache = 507,          /* cat7_data_cache  */
  YYSYMBOL_cat7_alias_src = 508,           /* cat7_alias_src  */
  YYSYMBOL_cat7_alias_scope = 509,         /* cat7_alias_scope  */
  YYSYMBOL_cat7_instr = 510,               /* cat7_instr  */
  YYSYMBOL_511_45 = 511,                   /* $@45  */
  YYSYMBOL_raw_instr = 512,                /* raw_instr  */
  YYSYMBOL_src = 513,                      /* src  */
  YYSYMBOL_dst = 514,                      /* dst  */
  YYSYMBOL_const = 515,                    /* const  */
  YYSYMBOL_dst_reg_flag = 516,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 517,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 518,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 519,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 520,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 521,                  /* src_reg  */
  YYSYMBOL_src_reg_gpr = 522,              /* src_reg_gpr  */
  YYSYMBOL_src_const = 523,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 524,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 525,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 526, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_src_reg_or_rel_or_imm = 527,    /* src_reg_or_rel_or_imm  */
  YYSYMBOL_offset = 528,                   /* offset  */
  YYSYMBOL_relative_gpr_src = 529,         /* relative_gpr_src  */
  YYSYMBOL_relative_gpr_dst = 530,         /* relative_gpr_dst  */
  YYSYMBOL_relative_const = 531,           /* relative_const  */
  YYSYMBOL_relative = 532,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 533,           /* immediate_cat1  */
  YYSYMBOL_immediate = 534,                /* immediate  */
  YYSYMBOL_flut_immed = 535,               /* flut_immed  */
  YYSYMBOL_integer = 536,                  /* integer  */
  YYSYMBOL_float = 537,                    /* float  */
  YYSYMBOL_type = 538                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 308 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 922 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1468

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  359
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  180
/* YYNRULES -- Number of rules.  */
#define YYNRULES  567
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1179

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   588


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   340,     2,   341,     2,     2,     2,     2,
     336,   337,     2,   347,   335,   334,   342,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   339,     2,
     348,   338,   357,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   350,     2,   351,     2,     2,     2,   343,     2,   354,
       2,     2,     2,   349,   358,     2,     2,   353,   352,     2,
       2,   344,   345,     2,   356,   346,     2,     2,     2,   355,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   708,   708,   708,   710,   711,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   726,   727,
     728,   729,   731,   737,   742,   750,   752,   752,   758,   764,
     771,   778,   787,   789,   791,   794,   796,   798,   805,   806,
     807,   808,   809,   810,   811,   813,   814,   816,   817,   819,
     820,   821,   822,   823,   824,   825,   826,   827,   828,   830,
     832,   833,   835,   836,   838,   839,   841,   842,   842,   843,
     843,   844,   844,   845,   845,   846,   846,   847,   847,   848,
     848,   849,   849,   850,   850,   851,   852,   852,   853,   854,
     855,   856,   857,   858,   859,   859,   860,   861,   862,   863,
     864,   864,   865,   866,   866,   867,   868,   868,   869,   869,
     870,   871,   871,   873,   876,   880,   881,   883,   883,   899,
     899,   906,   906,   913,   913,   915,   915,   917,   917,   920,
     921,   922,   923,   924,   925,   926,   927,   929,   930,   931,
     932,   933,   934,   935,   936,   937,   938,   939,   940,   941,
     942,   944,   945,   946,   947,   948,   949,   951,   952,   953,
     954,   955,   956,   957,   958,   959,   960,   961,   962,   963,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,   976,   977,   979,   980,   981,   982,   983,   984,
     986,   987,   988,   990,   991,   993,   994,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1013,  1014,  1015,  1016,  1017,  1019,  1020,
    1022,  1023,  1025,  1026,  1027,  1028,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1038,  1039,  1041,  1043,  1044,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,
    1088,  1089,  1091,  1092,  1093,  1094,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,
    1110,  1111,  1112,  1114,  1115,  1117,  1118,  1119,  1120,  1122,
    1123,  1124,  1125,  1126,  1127,  1129,  1132,  1137,  1140,  1146,
    1149,  1151,  1151,  1152,  1152,  1153,  1153,  1154,  1154,  1155,
    1155,  1156,  1156,  1156,  1160,  1160,  1161,  1161,  1162,  1162,
    1163,  1163,  1164,  1164,  1166,  1166,  1167,  1167,  1169,  1169,
    1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,
    1181,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,
    1192,  1193,  1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,
    1203,  1204,  1205,  1207,  1209,  1211,  1213,  1214,  1215,  1217,
    1219,  1220,  1222,  1223,  1224,  1224,  1227,  1228,  1229,  1231,
    1233,  1234,  1236,  1237,  1238,  1240,  1241,  1243,  1245,  1246,
    1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
    1258,  1260,  1261,  1262,  1264,  1268,  1269,  1271,  1277,  1278,
    1279,  1282,  1282,  1283,  1283,  1285,  1286,  1287,  1289,  1290,
    1291,  1292,  1293,  1294,  1295,  1296,  1297,  1298,  1299,  1300,
    1302,  1303,  1304,  1305,  1307,  1308,  1310,  1310,  1311,  1311,
    1313,  1314,  1315,  1317,  1318,  1320,  1321,  1322,  1324,  1325,
    1326,  1327,  1328,  1329,  1330,  1330,  1337,  1339,  1340,  1341,
    1342,  1344,  1345,  1346,  1347,  1349,  1351,  1352,  1353,  1354,
    1355,  1357,  1358,  1361,  1362,  1364,  1365,  1366,  1367,  1368,
    1370,  1371,  1373,  1374,  1376,  1377,  1379,  1380,  1382,  1383,
    1385,  1386,  1387,  1389,  1390,  1391,  1393,  1394,  1395,  1397,
    1398,  1399,  1401,  1402,  1404,  1405,  1407,  1408,  1410,  1411,
    1417,  1418,  1419,  1420,  1421,  1422,  1423,  1425,  1426,  1427,
    1428,  1429,  1432,  1433,  1434,  1435,  1436,  1437,  1438,  1439,
    1440,  1441,  1442,  1443,  1445,  1446,  1447,  1448,  1450,  1451,
    1453,  1454,  1455,  1456,  1457,  1458,  1459,  1460
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_A_PVTMEM",
  "T_A_EARLYPREAMBLE", "T_ABSNEG", "T_NEG", "T_ABS", "T_R", "T_LAST",
  "T_HR", "T_HC", "T_EVEN", "T_POS_INFINITY", "T_NEG_INFINITY", "T_EI",
  "T_WRMASK", "T_FLUT_0_0", "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0",
  "T_FLUT_E", "T_FLUT_PI", "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E",
  "T_FLUT_LOG2_E", "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0",
  "T_SY", "T_SS", "T_JP", "T_SAT", "T_RPT", "T_UL", "T_NOP", "T_OP_NOP",
  "T_OP_BR", "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC", "T_OP_BANY",
  "T_OP_BALL", "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL", "T_OP_RET",
  "T_OP_KILL", "T_OP_END", "T_OP_EMIT", "T_OP_CUT", "T_OP_CHMASK",
  "T_OP_CHSH", "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS", "T_OP_STKR",
  "T_OP_XSET", "T_OP_XCLR", "T_OP_GETLAST", "T_OP_GETONE", "T_OP_DBG",
  "T_OP_SHPS", "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF", "T_OP_PREDE",
  "T_OP_MOVMSK", "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV", "T_OP_COV",
  "T_OP_SWZ", "T_OP_GAT", "T_OP_SCT", "T_OP_ADD_F", "T_OP_MIN_F",
  "T_OP_MAX_F", "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F",
  "T_OP_ABSNEG_F", "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F",
  "T_OP_RNDNE_F", "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U",
  "T_OP_ADD_S", "T_OP_SUB_U", "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S",
  "T_OP_MIN_U", "T_OP_MIN_S", "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S",
  "T_OP_AND_B", "T_OP_OR_B", "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U",
  "T_OP_CMPV_S", "T_OP_MUL_U24", "T_OP_MUL_S24", "T_OP_MULL_U",
  "T_OP_BFREV_B", "T_OP_CLZ_S", "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B",
  "T_OP_ASHR_B", "T_OP_BARY_F", "T_OP_FLAT_B", "T_OP_MGEN_B",
  "T_OP_GETBIT_B", "T_OP_SETRM", "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD",
  "T_OP_MAD_U16", "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16",
  "T_OP_MAD_U24", "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32",
  "T_OP_SEL_B16", "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32",
  "T_OP_SEL_F16", "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32",
  "T_OP_SHRM", "T_OP_SHLM", "T_OP_SHRG", "T_OP_SHLG", "T_OP_ANDG",
  "T_OP_DP2ACC", "T_OP_DP4ACC", "T_OP_WMM", "T_OP_WMM_ACCU", "T_OP_RCP",
  "T_OP_RSQ", "T_OP_LOG2", "T_OP_EXP2", "T_OP_SIN", "T_OP_COS",
  "T_OP_SQRT", "T_OP_HRSQ", "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM",
  "T_OP_ISAML", "T_OP_ISAMM", "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML",
  "T_OP_SAMGQ", "T_OP_GETLOD", "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE",
  "T_OP_GETBUF", "T_OP_GETPOS", "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY",
  "T_OP_GATHER4R", "T_OP_GATHER4G", "T_OP_GATHER4B", "T_OP_GATHER4A",
  "T_OP_SAMGP0", "T_OP_SAMGP1", "T_OP_SAMGP2", "T_OP_SAMGP3",
  "T_OP_DSXPP_1", "T_OP_DSYPP_1", "T_OP_RGETPOS", "T_OP_RGETINFO",
  "T_OP_BRCST_A", "T_OP_QSHUFFLE_BRCST", "T_OP_QSHUFFLE_H",
  "T_OP_QSHUFFLE_V", "T_OP_QSHUFFLE_DIAG", "T_OP_TCINV", "T_OP_LDG",
  "T_OP_LDG_A", "T_OP_LDL", "T_OP_LDP", "T_OP_STG", "T_OP_STG_A",
  "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L", "T_OP_L2G",
  "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT", "T_OP_RESINFO",
  "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_ATOMIC_S_ADD", "T_OP_ATOMIC_S_SUB", "T_OP_ATOMIC_S_XCHG",
  "T_OP_ATOMIC_S_INC", "T_OP_ATOMIC_S_DEC", "T_OP_ATOMIC_S_CMPXCHG",
  "T_OP_ATOMIC_S_MIN", "T_OP_ATOMIC_S_MAX", "T_OP_ATOMIC_S_AND",
  "T_OP_ATOMIC_S_OR", "T_OP_ATOMIC_S_XOR", "T_OP_ATOMIC_G_ADD",
  "T_OP_ATOMIC_G_SUB", "T_OP_ATOMIC_G_XCHG", "T_OP_ATOMIC_G_INC",
  "T_OP_ATOMIC_G_DEC", "T_OP_ATOMIC_G_CMPXCHG", "T_OP_ATOMIC_G_MIN",
  "T_OP_ATOMIC_G_MAX", "T_OP_ATOMIC_G_AND", "T_OP_ATOMIC_G_OR",
  "T_OP_ATOMIC_G_XOR", "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC",
  "T_OP_LDLV", "T_OP_GETSPID", "T_OP_GETWID", "T_OP_GETFIBERID",
  "T_OP_STC", "T_OP_STSC", "T_OP_BAR", "T_OP_FENCE", "T_OP_SLEEP",
  "T_OP_ICINV", "T_OP_DCCLN", "T_OP_DCINV", "T_OP_DCFLU", "T_OP_LOCK",
  "T_OP_UNLOCK", "T_OP_ALIAS", "T_RAW", "T_TYPE_F16", "T_TYPE_F32",
  "T_TYPE_U16", "T_TYPE_U32", "T_TYPE_S16", "T_TYPE_S32", "T_TYPE_U8",
  "T_TYPE_S8", "T_UNTYPED", "T_TYPED", "T_MIXED", "T_UNSIGNED", "T_LOW",
  "T_HIGH", "T_1D", "T_2D", "T_3D", "T_4D", "T_LT", "T_LE", "T_GT", "T_GE",
  "T_EQ", "T_NE", "T_S2EN", "T_SAMP", "T_TEX", "T_BASE", "T_OFFSET",
  "T_UNIFORM", "T_NONUNIFORM", "T_IMM", "T_NAN", "T_INF", "T_A0", "T_A1",
  "T_P0", "T_W", "T_CAT1_TYPE_TYPE", "T_INSTR_TYPE", "T_MOD_TEX",
  "T_MOD_MEM", "T_MOD_RT", "'-'", "','", "'('", "')'", "'='", "':'", "'!'",
  "'#'", "'.'", "'a'", "'o'", "'p'", "'s'", "'+'", "'<'", "'g'", "'['",
  "']'", "'l'", "'k'", "'c'", "'w'", "'r'", "'>'", "'h'", "$accept",
  "shader", "$@1", "headers", "header", "const_val", "localsize_header",
  "const_header", "buf_header_addr_reg", "buf_header", "$@2",
  "invocationid_header", "wgid_header", "numwg_header",
  "branchstack_header", "pvtmem_header", "earlypreamble_header",
  "in_header", "out_header", "tex_header", "iflag", "iflags", "instrs",
  "instr", "label", "cat0_src1", "cat0_src2", "cat0_immed", "cat0_instr",
  "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12",
  "$@13", "$@14", "$@15", "$@16", "$@17", "$@18", "cat1_opc", "cat1_src",
  "cat1_movmsk", "$@19", "cat1_mova1", "$@20", "cat1_mova", "$@21",
  "cat1_swz", "$@22", "cat1_gat", "$@23", "cat1_sct", "$@24", "cat1_instr",
  "cat2_opc_1src", "cat2_opc_2src_cnd", "cat2_opc_2src", "cond",
  "cat2_instr", "cat3_dp_signedness", "cat3_dp_pack", "cat3_opc",
  "cat3_imm_reg_opc", "cat3_wmm", "cat3_dp", "cat3_instr", "cat4_opc",
  "cat4_instr", "cat5_opc_dsxypp", "cat5_opc", "cat5_flag", "cat5_flags",
  "cat5_samp", "cat5_tex", "cat5_type", "cat5_a1", "cat5_instr",
  "cat6_typed", "cat6_dim", "cat6_type", "cat6_imm_offset", "cat6_offset",
  "cat6_dst_offset", "cat6_immed", "cat6_a6xx_global_address_pt3",
  "cat6_a6xx_global_address_pt2", "cat6_a6xx_global_address", "cat6_load",
  "$@25", "$@26", "$@27", "$@28", "$@29", "$@30", "$@31", "cat6_store",
  "$@32", "$@33", "$@34", "$@35", "$@36", "cat6_loadib", "$@37",
  "cat6_storeib", "$@38", "cat6_prefetch", "$@39", "cat6_atomic_opc",
  "cat6_a3xx_atomic_opc", "cat6_a6xx_atomic_opc", "cat6_a3xx_atomic_s",
  "cat6_a6xx_atomic_g", "cat6_atomic_l", "cat6_atomic",
  "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb", "cat6_ibo_opc_stgb",
  "cat6_ibo", "$@40", "cat6_id_opc", "cat6_id", "cat6_bindless_base",
  "cat6_bindless_mode", "cat6_reg_or_immed", "cat6_bindless_ibo_opc_1src",
  "cat6_bindless_ibo_opc_2src", "cat6_bindless_ibo_opc_2src_dst",
  "cat6_bindless_ibo", "cat6_bindless_ldc_opc", "cat6_bindless_ldc_middle",
  "cat6_bindless_ldc", "stc_dst", "cat6_stc", "$@41", "$@42", "cat6_todo",
  "cat6_instr", "cat7_scope", "cat7_scopes", "cat7_barrier", "$@43",
  "$@44", "cat7_data_cache", "cat7_alias_src", "cat7_alias_scope",
  "cat7_instr", "$@45", "raw_instr", "src", "dst", "const", "dst_reg_flag",
  "dst_reg_flags", "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg",
  "src_reg_gpr", "src_const", "src_reg_or_const",
  "src_reg_or_const_or_rel", "src_reg_or_const_or_rel_or_imm",
  "src_reg_or_rel_or_imm", "offset", "relative_gpr_src",
  "relative_gpr_dst", "relative_const", "relative", "immediate_cat1",
  "immediate", "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-891)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-4)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -891,    32,  1059,  -891,    70,  -281,    70,  -228,  -216,  -208,
      70,  -198,  -178,  -174,    70,  -891,   769,  1059,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,   162,  -300,   201,  -891,   217,    69,   238,
    -891,   246,   248,   250,  -891,   -80,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,   620,  1179,   241,  -891,  -891,  -891,
    -891,  -891,    70,   -76,   -71,   -75,   -70,   -69,   -65,   -64,
     -63,   -55,  -891,  -891,  -891,  -891,  -891,  -891,   -59,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,   -57,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,   -44,   -26,   -24,   -37,   -36,
     -35,   -21,   -15,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,   141,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,   146,   -13,   146,  -891,   146,   146,   146,   -12,  -891,
     146,  -891,    -7,    -7,  -891,  -891,  -891,  -891,  -891,  -891,
      -5,    -5,    -5,  -891,  -891,  -891,  -891,    -3,    -5,    -5,
    -891,    -3,  -891,    -5,    -5,    -5,  -891,    -2,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,    10,    70,   334,  -891,
    -891,  -891,  -891,  -891,   338,   351,   352,  -289,  -289,  -289,
      87,  -289,  -289,    18,    18,    18,  -289,    18,    40,    18,
      18,  -289,  -289,    46,    25,    35,    49,    50,    54,    55,
      57,    -3,    -3,    -3,    -3,    -3,    -3,    -3,    -3,    -5,
      22,    -3,    -3,    -5,    -3,    -3,    -3,    45,    45,    48,
    -891,    44,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
      51,  -891,   173,   112,    85,    95,    96,   -98,   105,   111,
     114,   116,  -147,    77,   120,   709,    -7,   146,   117,  -104,
     119,   119,   119,  -110,   119,   119,   119,   146,   119,   119,
     119,     9,    70,   123,   110,   126,   133,   132,  -891,   147,
     140,   148,   154,  -891,  -891,   223,  -891,   155,   157,    12,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,   146,   146,
     146,   146,   144,   149,   129,   137,   119,   145,   146,   150,
     119,   146,   142,   151,  -192,    45,  -891,  -891,  -220,   176,
     178,  -891,  -891,   687,   687,   766,  -891,  -891,  -891,  -891,
    -891,  -891,   146,   766,    37,   872,   109,  -891,  -891,   -74,
     146,   766,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,   169,  -110,   146,  -891,  -891,    42,    -3,
      -3,    -3,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,   146,    -3,    -3,  -891,    -3,    -3,    -3,   165,   167,
     175,  -891,  -891,    70,  -891,   507,   509,    87,  -891,    18,
    -262,  -262,  -891,  -891,    18,    18,    18,  -891,  -891,    18,
     146,   687,   687,   146,   146,   146,   181,   182,   183,   185,
     174,   190,   191,   194,    -3,   152,   188,   195,    -3,   200,
     196,   202,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
     218,  -264,  -264,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
     214,   215,  -891,  -891,  -891,    43,   216,   219,   230,  -891,
    -891,  -891,   211,    26,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,    87,   721,   614,  -891,
    -891,  -891,  -891,  -891,   224,   233,   235,   152,  -891,   236,
    -891,  -891,  -891,   239,  -891,  -891,  -891,   247,  -891,   301,
     199,   256,  -891,  -891,  -891,  -891,   252,   253,   254,   257,
     255,   258,   261,   262,   265,    87,   228,     7,   263,   245,
     270,   274,  -891,  -891,   284,   279,   280,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,   281,   285,   288,   282,   283,   267,
     290,   152,   526,   152,   152,   287,  -253,   291,   152,   294,
     292,    76,    76,   303,    87,    87,   302,   321,   312,   317,
    -891,   308,   323,   186,   342,   343,   357,   359,    84,  -891,
    -891,  -891,  -891,   349,    87,  -891,  -891,   766,   766,   526,
     526,   301,   872,  -891,  -891,   505,    87,    87,    87,   344,
      87,    87,    87,    87,    87,   350,   363,   364,  -891,  -891,
      70,    87,    87,   700,  -891,    18,    18,   146,   301,   146,
     365,   367,   368,   370,  -264,   356,    99,   374,  -155,  -155,
      87,     7,  -891,   373,  -891,   376,  -155,    87,   378,   382,
     380,  -891,   381,   392,  -891,  -891,  -891,  -891,  -264,  -264,
    -891,  -891,  -891,  -891,  -891,  -264,  -264,   398,   399,  -891,
     401,   404,  -891,   405,   407,   410,   411,  -891,  -891,   412,
    -891,   415,   409,   425,   426,   402,   146,  -891,   429,   434,
     435,  -101,  -101,     7,   443,   448,   449,   457,  -891,  -891,
     461,   463,   476,   152,   526,   152,   152,   462,   488,    29,
       7,   473,  -891,   474,   146,  -891,   491,   152,   477,   478,
      87,    87,   494,   498,    87,   479,   480,   484,   489,  -891,
    -891,  -891,   766,    37,   872,   276,   526,   518,   505,   493,
     499,   501,     7,   512,   511,  -101,  -101,  -101,   514,   514,
     514,   146,   500,  -891,    70,  -891,  -891,    87,   301,   301,
     146,  -253,   515,  -253,  -253,   530,   152,   152,  -891,  -105,
    -891,   533,   534,   535,    87,  -253,   536,   531,   529,  -891,
     301,   276,   146,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,   548,  -891,   549,  -891,   550,   146,   146,   146,   537,
     538,   539,   146,   301,   146,   574,  -891,  -891,  -891,  -891,
     551,  -891,   555,   565,   567,   568,   553,   584,   569,   570,
     152,   587,  -264,     7,   578,  -891,   152,   152,   583,  -891,
     582,   152,   276,  -891,   592,   599,   600,   872,   532,   505,
     601,   602,   603,  -891,   593,     7,   609,   610,   611,  -891,
     621,   943,   301,   301,   146,   616,   276,   617,   618,   619,
     276,   622,  -891,    87,   623,   625,   605,   628,   630,   606,
     631,    87,    87,   118,  -891,  -891,  -891,  -891,   632,  -891,
    -891,   604,   633,   152,     7,   639,     7,     7,     7,   642,
     643,  -891,   634,   636,   276,  -891,   276,   276,   276,  -891,
     649,  -264,   276,   276,   276,   276,   276,   666,   276,  -891,
    -891,  -891,  -891,  -891,   532,   652,   654,   673,   658,   675,
    -891,   676,   680,  -891,    87,   301,   301,  -891,  -891,  -891,
    -891,   669,   670,  -891,  -891,   668,  -891,  -891,   152,  -891,
    -891,  -891,     7,     7,   152,   685,   152,     7,     7,   690,
    -891,  -891,    87,   674,   691,   693,   681,   682,  -891,   152,
     696,  -891,  -891,  1028,  -891,    87,   152,   152,   701,   703,
     704,     7,   697,  -891,   705,   707,   152,   152,   152,   712,
      87,   152,   152,  -891,   713,  -891,   152,   714,  -891,  -891,
     152,  -891,  1038,   716,   718,   152,    87,  -891,  -891
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    45,     4,     6,     7,
       8,     9,    10,    11,    12,    16,    17,    13,    14,    15,
      19,    21,    18,     0,     0,     0,    26,     0,     0,     0,
      32,     0,     0,     0,    33,     0,    38,    39,    40,    41,
      42,    43,    44,   476,    45,     0,    45,    48,    58,    57,
       5,    20,     0,     0,    25,     0,     0,     0,     0,     0,
       0,     0,    59,    46,    66,    67,    69,    71,     0,    75,
      77,    79,    81,    83,    85,    86,    88,    89,    90,    91,
      92,    93,    94,    96,    97,    98,    99,     0,   100,   102,
     103,   105,   106,   108,   110,     0,     0,     0,     0,     0,
       0,     0,     0,   157,   158,   159,   160,   141,   151,   137,
     154,   142,   143,   144,   145,   146,   161,   162,   163,   164,
     152,   153,   165,   166,   167,   168,   138,   169,   170,   147,
     171,   155,   156,   172,   173,   174,   148,   140,   139,   175,
     176,   177,   178,   179,   180,   181,   149,   150,   182,   183,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   220,   221,   218,   219,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   237,
     238,   263,   264,   265,   266,   267,   268,   269,   302,   321,
     323,   327,   325,   334,   336,   340,   338,   344,   435,   436,
     348,   329,   342,   437,   389,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   407,   420,   419,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   390,   391,   346,   424,   331,   396,   397,   398,
     431,   433,   456,   458,   470,   471,   460,   461,   462,   472,
     473,   474,    49,     0,   129,   130,   131,   132,   133,   134,
      50,     0,     0,     0,    51,     0,     0,     0,     0,    52,
       0,    53,   280,   280,    54,   438,   440,   439,   441,   442,
       0,     0,     0,   387,   388,   386,   443,     0,     0,     0,
     444,     0,   445,     0,     0,     0,   447,     0,   446,   448,
     449,    55,   468,   469,    56,    47,     0,     0,     0,    27,
      28,    29,    30,    31,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   454,   454,     0,
     481,     0,   486,   487,   488,   489,   490,   482,   483,   484,
       0,   493,   491,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   280,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    61,     0,
       0,     0,     0,   554,   556,     0,    73,     0,     0,     0,
      80,    82,    84,    87,    95,   111,   101,   104,   107,   109,
     117,   119,   121,   113,   114,   123,   125,   127,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   454,   457,   459,     0,     0,
       0,   492,   494,     0,     0,     0,   184,   185,   186,   187,
     188,   189,     0,     0,     0,     0,     0,   193,   194,     0,
       0,     0,   270,   275,   278,   276,   277,   279,   271,   272,
     273,   274,   281,     0,     0,     0,   303,   304,     0,     0,
       0,     0,   560,   561,   562,   563,   564,   565,   566,   567,
     309,     0,     0,     0,   399,     0,     0,     0,     0,     0,
       0,   315,    22,     0,    24,     0,     0,     0,    60,     0,
       0,     0,   555,   557,     0,     0,     0,    65,    64,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   453,   452,   450,   451,   455,   465,   466,   467,
       0,   519,   519,   477,   485,   495,   496,   497,   498,   499,
       0,     0,   478,   479,   480,     0,     0,     0,     0,   135,
     502,   506,   500,     0,   508,   509,   510,   115,   528,   529,
     511,   116,   530,   136,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,     0,     0,     0,   513,
     190,   515,   539,   537,     0,     0,     0,     0,   516,     0,
     517,   518,   504,     0,   505,   195,   196,     0,   236,     0,
       0,   301,   305,   306,   307,   308,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    68,    63,     0,     0,     0,    74,    76,    78,
     112,   118,   120,   122,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   519,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     558,     0,     0,     0,     0,     0,     0,     0,     0,   501,
     503,   507,   512,     0,     0,   541,   514,     0,     0,     0,
       0,     0,     0,   286,   284,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   405,   406,
       0,     0,     0,     0,    62,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   519,     0,     0,     0,   519,   519,
       0,     0,   311,     0,   310,     0,   519,     0,     0,   429,
       0,   428,     0,     0,   521,   520,   525,   524,   519,   519,
     535,   536,   559,   531,   532,   519,   519,     0,     0,   538,
       0,     0,   192,     0,     0,     0,     0,   282,   283,   299,
     300,   297,     0,     0,     0,     0,     0,   394,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    70,    72,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   313,     0,     0,   312,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   533,
     534,   540,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   400,   400,
     400,     0,     0,   427,     0,    35,    36,     0,     0,     0,
       0,   519,     0,   519,   519,     0,     0,     0,   320,     0,
     314,     0,     0,     0,     0,   519,     0,     0,     0,   430,
       0,     0,     0,   523,   527,   526,   522,   191,   222,   223,
     224,     0,   298,   295,   296,   292,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   403,   404,   402,   425,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   519,     0,     0,   319,     0,     0,     0,   349,
       0,     0,     0,   332,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   392,     0,     0,     0,     0,     0,   401,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   317,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   225,   293,   294,   285,   290,   291,
     287,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   124,     0,     0,     0,   324,     0,     0,     0,   337,
       0,   519,     0,     0,     0,     0,     0,     0,     0,   432,
     434,   475,   463,   464,     0,     0,     0,     0,     0,     0,
     421,     0,     0,   426,     0,     0,     0,   322,   328,   326,
     335,     0,     0,   341,   339,     0,   330,   343,     0,   333,
     288,   289,     0,     0,     0,     0,     0,     0,     0,     0,
     126,   128,     0,     0,     0,     0,     0,     0,   384,     0,
       0,   422,   423,     0,   318,     0,     0,     0,     0,     0,
       0,     0,     0,   316,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   385,     0,   393,     0,     0,   345,   347,
       0,   395,     0,     0,     0,     0,     0,   383,    37
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -891,  -891,  -891,  1041,  -891,    -6,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  1006,  -891,  1007,  -891,  -277,   490,  -318,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -503,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -310,  -890,  -825,
    -891,   -30,  -891,   576,   540,   572,   251,  -794,  -716,   -90,
    -891,  -891,   198,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,  -679,  -830,   -61,
    -891,  -891,  -891,  -891,  -891,  -891,  -891,   328,  -891,  -891,
    -891,  -891,  -891,  -891,  -364,  -891,  -891,  -891,  -891,  -891,
    -891,  -891,  -891,  -891,  -284,   650,  -610,  -891,   653,  -301,
    -891,  -484,  -533,  -891,  -891,  -656,  -517,  -514,  -777,  -601,
     552,  -891,  -891,  -526,    31,  -498,   417,  -379,   318,   541
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    16,    17,    34,    18,    19,   369,    20,
      64,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      54,    55,    56,    57,    58,   470,   725,   480,   312,   377,
     378,   379,   594,   381,   382,   383,   384,   385,   386,   387,
     389,   390,   391,   392,   599,   313,   649,   314,   600,   315,
     601,   316,   602,   317,   603,   318,   604,   319,   605,   320,
     321,   322,   323,   532,   324,   443,   540,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   446,   447,   859,   860,
     555,  1056,   334,   450,   559,   454,   822,   823,   891,   579,
    1005,   948,   815,   335,   401,   402,   404,   403,   411,   414,
    1050,   336,   405,   406,   408,   407,   412,   337,   409,   338,
     413,   339,   410,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   924,   351,   352,   986,   931,   797,
     353,   354,   355,   356,   357,   580,   358,   830,   359,   415,
     416,   360,   361,   515,   516,   362,   417,   418,   363,  1091,
     630,   364,   419,    59,   650,   431,   651,   432,   433,   434,
     652,   687,   654,   693,   655,   656,   679,   680,   689,   824,
     658,   435,   659,   660,   661,   681,   682,   683,   765,   570
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      36,   476,   688,   692,    40,   856,   657,   657,    44,   690,
     473,   474,   473,   474,   633,   473,   474,   686,   597,   685,
     436,   663,   438,   448,   439,   440,   441,   698,   973,   444,
     756,   757,     3,   633,   634,    62,   633,   691,   468,   653,
     653,   678,   932,   771,   633,   634,   473,   474,   760,   678,
     653,   469,   640,   641,   517,    35,   366,   678,   635,   636,
     637,   638,   639,   640,   641,   723,   481,   482,   771,   484,
     754,   486,   487,    30,    31,    32,    66,    67,   724,   473,
     474,   754,   581,   755,   657,   657,   817,   473,   474,   760,
     473,   474,   972,   974,   821,   982,   983,   984,   732,   733,
     598,   471,   472,   893,   477,   478,   633,   634,    37,   483,
     898,   627,   628,   629,   488,   489,   633,   653,   653,   420,
      38,   473,   474,   853,   854,   633,   634,   772,    39,  1058,
     635,   636,   637,   638,   639,   640,   552,   969,    41,   635,
     636,   637,   638,   639,   662,   662,   553,   996,   420,   998,
     999,   626,   772,   420,   537,   538,   574,   622,    42,   633,
     623,  1010,    43,   624,   625,    61,   783,   421,   769,   422,
     423,   424,   425,   426,   422,   423,   424,   425,   426,   754,
     776,   562,   563,   564,   565,   566,   567,   568,   569,   592,
     593,   842,   890,  1055,  1059,   556,   557,   606,   607,   608,
     609,   422,   423,   424,   425,   426,   771,   616,   721,    63,
     619,   526,   527,   528,   529,   530,   531,   892,   892,   928,
     929,   930,   662,   662,    65,   892,   592,   593,   817,   695,
     696,   684,   635,   636,   637,   638,   639,   905,   906,   697,
    1054,    -3,  1003,  1004,   907,   908,    68,    45,   855,   688,
     987,   988,   861,    69,   701,    70,   690,    71,   816,    72,
     971,   367,   370,   851,   852,   368,   764,   371,   372,  1120,
     709,   722,   373,   374,   375,   881,   727,   728,   729,   473,
     474,   730,   376,   380,   691,   388,    46,    47,    48,    49,
      50,    51,    52,   678,   678,   816,   816,   773,   393,   731,
     394,   395,   734,   735,   736,   396,   397,   398,   633,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   399,   635,   636,   637,   638,   639,   400,   578,   437,
     442,   746,   642,   643,   644,   445,   581,   449,   799,   453,
     461,   475,   464,   475,   465,   462,   475,   702,   703,   704,
     705,   642,   643,   644,   642,   643,   644,   466,   467,   479,
     491,   463,   642,   643,   644,   947,   761,   762,   485,   770,
     492,   507,   831,   831,   490,   834,   835,   763,   493,   494,
     646,   688,   647,   495,   496,   975,   497,   514,   690,   847,
     518,   646,   519,   647,   770,   850,   968,  1092,   967,   520,
     816,  1041,   829,   770,    33,   993,   994,   581,   581,   581,
     475,   581,   581,   581,   581,   581,   691,   970,   763,   539,
     523,   475,   875,   876,   642,   643,   644,  1014,   678,   653,
     524,   525,   816,   798,   642,   643,   644,   427,   428,   429,
     533,   581,   835,   642,   643,   644,   534,   584,   581,   535,
    1027,   536,   475,   554,   645,   541,   582,   814,   583,   818,
     819,   558,   585,  1015,   826,   647,   427,   428,   429,   586,
     587,   427,   428,   429,   588,   589,   648,   642,   643,   644,
    1112,   612,   613,   590,   688,  1057,  1060,   878,   879,   591,
     595,   690,   596,   610,   799,   615,   620,   430,   611,  1071,
    1072,   631,   617,   632,   699,   621,   880,   715,   882,   716,
     717,   835,   633,   719,  1049,   720,   737,   738,   739,   691,
     740,   958,   959,   747,   741,   962,   635,   636,   637,   638,
     639,    53,   770,   633,   634,   750,   784,   895,  1075,   633,
     742,   743,  1079,   799,   744,   748,   751,   635,   636,   637,
     638,   639,   752,   635,   636,   637,   638,   639,   992,   777,
     753,  1057,   758,   759,   766,   923,   768,   767,   778,   816,
     779,   780,  1130,  1131,   781,   581,  1107,   718,  1108,  1109,
    1110,   796,   782,   801,  1113,  1114,  1115,  1116,  1117,   798,
    1119,   785,   789,   953,   786,   787,   788,   790,   800,   941,
     791,   943,   944,   792,   793,   949,   950,   794,   802,   803,
     475,   804,   676,   955,   805,   806,   807,   473,   474,   812,
     808,   633,   634,   809,   799,   795,   642,   643,   644,   820,
     989,   810,   811,   833,   677,   813,   827,   838,   798,   995,
     640,   641,   839,   825,   828,   840,   799,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   836,
     841,  1016,  1001,  1002,  1081,    46,    47,    48,    49,    50,
      51,    52,   581,   581,   662,  1020,  1021,  1022,   837,   843,
     844,  1026,   845,  1028,   846,   799,   849,   799,   799,   799,
     473,   474,   871,   865,   633,   634,   862,   863,   864,   873,
     866,   867,   868,   869,   870,   872,   877,   888,   635,   636,
     637,   638,   639,   640,   641,   883,  1039,   884,   885,   798,
     886,   889,  1044,  1045,   896,  1129,   897,  1048,   900,   901,
     894,   902,   903,  1073,   904,   909,   910,   899,   911,   912,
     913,   798,   914,   799,   799,   915,   916,   917,   799,   799,
     918,   919,   922,  1144,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,   674,   675,  1153,   920,   921,   473,
     474,   925,   799,   633,   634,    45,   926,   927,   934,  1097,
     798,  1167,   798,   798,   798,   935,   936,   635,   636,   637,
     638,   639,   640,   641,   874,   937,   938,  1178,   939,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   940,   933,   945,    46,    47,    48,    49,    50,    51,
      52,   857,   858,   946,   951,   952,   954,   957,   956,   960,
     642,   643,   644,   961,  1135,   858,   963,   964,   798,   798,
    1138,   965,  1140,   798,   798,   976,   966,   980,   977,   858,
     978,   642,   643,   644,   990,  1150,   985,   642,   643,   644,
     981,   979,  1154,  1155,  1009,  1000,   997,   798,  1006,  1007,
    1008,  1011,  1163,  1164,  1165,   473,   474,  1168,  1169,   633,
    1013,  1012,  1171,  1017,  1018,  1019,  1173,  1024,  1023,  1025,
    1031,  1177,  1029,   635,   636,   637,   638,   639,   640,   641,
    1032,  1030,  1033,  1034,  1035,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   451,   452,  1036,
    1037,  1038,  1040,   457,   455,   456,  1043,  1051,   991,   458,
     459,   460,  1046,  1047,  1052,  1053,  1061,  1062,  1063,   642,
     643,   644,  1042,  1064,  1066,  1067,  1068,  1069,   475,  1070,
     676,  1074,  1076,  1077,  1078,  1084,  1095,  1087,  1082,  1080,
    1083,  1089,  1090,  1085,  1065,  1086,  1088,  1094,   646,  1105,
     647,  1106,   677,   498,   499,   500,   501,   502,   503,   504,
     505,  1104,  1096,   508,   509,   506,   511,   512,   513,   510,
    1099,   560,   561,  1103,   571,   572,   573,  1111,   575,   576,
     577,  1118,  1122,  1098,  1123,  1100,  1101,  1102,  1124,  1125,
    1126,  1127,   642,   643,   644,  1128,   542,  1132,  1133,  1134,
    1139,   475,  1145,   645,   543,  1143,  1146,   544,  1147,   545,
     546,  1151,  1148,  1149,  1152,  1160,  1156,   547,  1157,  1158,
    1161,   646,  1162,   647,  1174,   648,   614,  1166,  1170,  1172,
     618,  1175,   548,   549,   550,   551,  1176,   774,    60,    53,
      73,  1136,  1137,   365,  1121,   887,  1141,  1142,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
     832,   726,   942,   522,  1093,   521,   848,     0,   694,     0,
    1159,   642,   643,   644,   775,   700,     0,     0,     0,     0,
     475,     0,   676,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     646,     0,   647,     0,   677,     0,     0,     0,     0,     0,
       0,   706,   707,   708,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   710,   711,     0,   712,   713,   714,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   745,     0,     0,     0,
     749,     0,     0,     0,     0,     0,     0,   642,   643,   644,
       0,     0,     0,     0,     0,     0,   475,     0,   676,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   646,     0,   647,     0,
     677,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311
};

static const yytype_int16 yycheck[] =
{
       6,   380,   535,   536,    10,   782,   523,   524,    14,   535,
       3,     4,     3,     4,     7,     3,     4,   534,     6,   533,
     321,   524,   323,   333,   325,   326,   327,   541,   918,   330,
     631,   632,     0,     7,     8,   335,     7,   535,   327,   523,
     524,   525,   872,   653,     7,     8,     3,     4,     5,   533,
     534,   340,    26,    27,   418,   336,    62,   541,    21,    22,
      23,    24,    25,    26,    27,   327,   384,   385,   678,   387,
     334,   389,   390,     3,     4,     5,     7,     8,   340,     3,
       4,   334,   461,   347,   601,   602,   742,     3,     4,     5,
       3,     4,   917,   918,   347,   925,   926,   927,   601,   602,
     479,   378,   379,   819,   381,   382,     7,     8,   336,   386,
     826,   331,   332,   333,   391,   392,     7,   601,   602,     7,
     336,     3,     4,   779,   780,     7,     8,   653,   336,  1019,
      21,    22,    23,    24,    25,    26,   446,   914,   336,    21,
      22,    23,    24,    25,   523,   524,   447,   941,     7,   943,
     944,   515,   678,     7,   301,   302,   457,   349,   336,     7,
     352,   955,   336,   355,   356,     3,   699,    26,   652,    28,
      29,    30,    31,    32,    28,    29,    30,    31,    32,   334,
     678,   291,   292,   293,   294,   295,   296,   297,   298,     3,
       4,     5,   347,  1018,  1019,   299,   300,   498,   499,   500,
     501,    28,    29,    30,    31,    32,   816,   508,   587,     8,
     511,   309,   310,   311,   312,   313,   314,   818,   819,   320,
     321,   322,   601,   602,     7,   826,     3,     4,   884,   303,
     304,   532,    21,    22,    23,    24,    25,   838,   839,   540,
    1017,     0,   347,   348,   845,   846,     8,     6,   781,   782,
     929,   930,   785,     7,   555,     7,   782,     7,   742,   339,
     916,   337,   337,   777,   778,   336,   645,   337,   337,  1094,
     571,   589,   337,   337,   337,   808,   594,   595,   596,     3,
       4,   599,   337,   342,   782,   342,    45,    46,    47,    48,
      49,    50,    51,   777,   778,   779,   780,   676,   342,   600,
     326,   325,   603,   604,   605,   342,   342,   342,     7,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,   342,    21,    22,    23,    24,    25,   342,   319,   342,
     342,   615,   325,   326,   327,   342,   715,   342,   717,   342,
     342,   334,     8,   334,     6,   335,   334,   305,   306,   307,
     308,   325,   326,   327,   325,   326,   327,     6,     6,   341,
     335,   367,   325,   326,   327,   336,   323,   324,   328,   653,
     335,   349,   751,   752,   328,   754,   755,   334,   329,   329,
     354,   914,   356,   329,   329,   918,   329,   342,   914,   768,
     342,   354,   348,   356,   678,   774,   913,  1053,   912,   348,
     884,  1002,   326,   687,   334,   938,   939,   786,   787,   788,
     334,   790,   791,   792,   793,   794,   914,   915,   334,   342,
     335,   334,   801,   802,   325,   326,   327,   960,   912,   913,
     335,   335,   916,   717,   325,   326,   327,   325,   326,   327,
     335,   820,   821,   325,   326,   327,   335,   337,   827,   335,
     983,   335,   334,   336,   336,   335,   462,   741,   335,   743,
     744,   342,   336,   961,   748,   356,   325,   326,   327,   336,
     338,   325,   326,   327,   327,   335,   358,   325,   326,   327,
    1081,   352,   345,   335,  1017,  1018,  1019,   805,   806,   335,
     335,  1017,   335,   349,   873,   350,   354,   356,   349,  1032,
    1033,   325,   352,   325,   335,   354,   807,   342,   809,   342,
     335,   890,     7,     6,  1012,     6,   335,   335,   335,  1017,
     335,   900,   901,   335,   350,   904,    21,    22,    23,    24,
      25,   290,   816,     7,     8,   335,   337,   821,  1036,     7,
     350,   350,  1040,   922,   350,   350,   350,    21,    22,    23,
      24,    25,   350,    21,    22,    23,    24,    25,   937,   335,
     342,  1094,   348,   348,   348,   866,   336,   348,   335,  1053,
     335,   335,  1105,  1106,   335,   954,  1074,   583,  1076,  1077,
    1078,   353,   335,   338,  1082,  1083,  1084,  1085,  1086,   873,
    1088,   335,   335,   894,   342,   342,   342,   342,   335,   883,
     342,   885,   886,   342,   342,   889,   890,   342,   338,   335,
     334,   327,   336,   897,   335,   335,   335,     3,     4,   352,
     335,     7,     8,   335,  1003,   715,   325,   326,   327,   342,
     931,   349,   349,   330,   358,   345,   342,   325,   922,   940,
      26,    27,   325,   352,   352,   337,  1025,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,   357,
     337,   962,   946,   947,  1043,    45,    46,    47,    48,    49,
      50,    51,  1051,  1052,  1053,   976,   977,   978,   357,   337,
     337,   982,   325,   984,   325,  1064,   337,  1066,  1067,  1068,
       3,     4,   342,   349,     7,     8,   786,   787,   788,   335,
     790,   791,   792,   793,   794,   342,     6,   351,    21,    22,
      23,    24,    25,    26,    27,   350,  1000,   350,   350,  1003,
     350,   347,  1006,  1007,   351,  1104,   350,  1011,   350,   347,
     820,   351,   351,  1034,   342,   337,   337,   827,   337,   335,
     335,  1025,   335,  1122,  1123,   335,   335,   335,  1127,  1128,
     335,   342,   350,  1132,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,  1145,   342,   342,     3,
       4,   342,  1151,     7,     8,     6,   342,   342,   335,  1063,
    1064,  1160,  1066,  1067,  1068,   337,   337,    21,    22,    23,
      24,    25,    26,    27,   800,   338,   335,  1176,   335,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,   335,   873,   351,    45,    46,    47,    48,    49,    50,
      51,   316,   317,   335,   351,   351,   335,   349,   351,   335,
     325,   326,   327,   335,  1118,   317,   357,   357,  1122,  1123,
    1124,   357,  1126,  1127,  1128,   352,   357,   335,   349,   317,
     349,   325,   326,   327,   354,  1139,   342,   325,   326,   327,
     349,   922,  1146,  1147,   954,   335,   351,  1151,   335,   335,
     335,   335,  1156,  1157,  1158,     3,     4,  1161,  1162,     7,
     351,   350,  1166,   335,   335,   335,  1170,   349,   351,   350,
     335,  1175,   318,    21,    22,    23,    24,    25,    26,    27,
     335,   350,   335,   335,   351,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,   341,   342,   335,
     351,   351,   335,   351,   348,   349,   348,   335,   934,   353,
     354,   355,   349,   351,   335,   335,   335,   335,   335,   325,
     326,   327,  1003,   350,   335,   335,   335,   326,   334,     6,
     336,   335,   335,   335,   335,   350,   352,   351,   335,   337,
     335,  1051,  1052,   335,  1025,   335,   335,   335,   354,   335,
     356,   335,   358,   401,   402,   403,   404,   405,   406,   407,
     408,   338,   349,   411,   412,   409,   414,   415,   416,   413,
     351,   451,   452,   351,   454,   455,   456,   348,   458,   459,
     460,   335,   350,  1064,   350,  1066,  1067,  1068,   335,   351,
     335,   335,   325,   326,   327,   335,   307,   348,   348,   351,
     335,   334,   348,   336,   315,   335,   335,   318,   335,   320,
     321,   335,   351,   351,     6,   338,   335,   328,   335,   335,
     335,   354,   335,   356,     6,   358,   506,   335,   335,   335,
     510,   335,   343,   344,   345,   346,   338,   336,    17,   290,
      54,  1122,  1123,    56,  1094,   814,  1127,  1128,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
     752,   591,   884,   433,  1053,   432,   768,    -1,   536,    -1,
    1151,   325,   326,   327,   677,   554,    -1,    -1,    -1,    -1,
     334,    -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     354,    -1,   356,    -1,   358,    -1,    -1,    -1,    -1,    -1,
      -1,   559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   572,   573,    -1,   575,   576,   577,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   614,    -1,    -1,    -1,
     618,    -1,    -1,    -1,    -1,    -1,    -1,   325,   326,   327,
      -1,    -1,    -1,    -1,    -1,    -1,   334,    -1,   336,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,   356,    -1,
     358,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   360,   361,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   362,   363,   365,   366,
     368,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       3,     4,     5,   334,   364,   336,   364,   336,   336,   336,
     364,   336,   336,   336,   364,     6,    45,    46,    47,    48,
      49,    50,    51,   290,   379,   380,   381,   382,   383,   512,
     362,     3,   335,     8,   369,     7,     7,     8,     8,     7,
       7,     7,   339,   380,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   387,   404,   406,   408,   410,   412,   414,   416,
     418,   419,   420,   421,   423,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   441,   452,   460,   466,   468,   470,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   484,   485,   489,   490,   491,   492,   493,   495,   497,
     500,   501,   504,   507,   510,   382,   364,   337,   336,   367,
     337,   337,   337,   337,   337,   337,   337,   388,   389,   390,
     342,   392,   393,   394,   395,   396,   397,   398,   342,   399,
     400,   401,   402,   342,   326,   325,   342,   342,   342,   342,
     342,   453,   454,   456,   455,   461,   462,   464,   463,   467,
     471,   457,   465,   469,   458,   498,   499,   505,   506,   511,
       7,    26,    28,    29,    30,    31,    32,   325,   326,   327,
     356,   514,   516,   517,   518,   530,   518,   342,   518,   518,
     518,   518,   342,   424,   518,   342,   435,   436,   436,   342,
     442,   442,   442,   342,   444,   442,   442,   444,   442,   442,
     442,   342,   335,   364,     8,     6,     6,     6,   327,   340,
     384,   384,   384,     3,     4,   334,   536,   384,   384,   341,
     386,   386,   386,   384,   386,   328,   386,   386,   384,   384,
     328,   335,   335,   329,   329,   329,   329,   329,   444,   444,
     444,   444,   444,   444,   444,   444,   442,   349,   444,   444,
     442,   444,   444,   444,   342,   502,   503,   503,   342,   348,
     348,   517,   514,   335,   335,   335,   309,   310,   311,   312,
     313,   314,   422,   335,   335,   335,   335,   301,   302,   342,
     425,   335,   307,   315,   318,   320,   321,   328,   343,   344,
     345,   346,   436,   518,   336,   439,   299,   300,   342,   443,
     443,   443,   291,   292,   293,   294,   295,   296,   297,   298,
     538,   443,   443,   443,   518,   443,   443,   443,   319,   448,
     494,   536,   364,   335,   337,   336,   336,   338,   327,   335,
     335,   335,     3,     4,   391,   335,   335,     6,   536,   403,
     407,   409,   411,   413,   415,   417,   518,   518,   518,   518,
     349,   349,   352,   345,   443,   350,   518,   352,   443,   518,
     354,   354,   349,   352,   355,   356,   503,   331,   332,   333,
     509,   325,   325,     7,     8,    21,    22,    23,    24,    25,
      26,    27,   325,   326,   327,   336,   354,   356,   358,   405,
     513,   515,   519,   520,   521,   523,   524,   525,   529,   531,
     532,   533,   536,   405,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,   336,   358,   520,   525,
     526,   534,   535,   536,   518,   526,   525,   520,   521,   527,
     532,   534,   521,   522,   529,   303,   304,   518,   526,   335,
     538,   518,   305,   306,   307,   308,   444,   444,   444,   518,
     444,   444,   444,   444,   444,   342,   342,   335,   364,     6,
       6,   536,   386,   327,   340,   385,   385,   386,   386,   386,
     386,   518,   405,   405,   518,   518,   518,   335,   335,   335,
     335,   350,   350,   350,   350,   444,   513,   335,   350,   444,
     335,   350,   350,   342,   334,   347,   528,   528,   348,   348,
       5,   323,   324,   334,   536,   537,   348,   348,   336,   520,
     513,   515,   532,   536,   336,   535,   534,   335,   335,   335,
     335,   335,   335,   521,   337,   335,   342,   342,   342,   335,
     342,   342,   342,   342,   342,   448,   353,   488,   513,   536,
     335,   338,   338,   335,   327,   335,   335,   335,   335,   335,
     349,   349,   352,   345,   513,   451,   520,   524,   513,   513,
     342,   347,   445,   446,   528,   352,   513,   342,   352,   326,
     496,   536,   496,   330,   536,   536,   357,   357,   325,   325,
     337,   337,     5,   337,   337,   325,   325,   536,   537,   337,
     536,   526,   526,   524,   524,   521,   527,   316,   317,   437,
     438,   521,   448,   448,   448,   349,   448,   448,   448,   448,
     448,   342,   342,   335,   364,   536,   536,     6,   386,   386,
     518,   521,   518,   350,   350,   350,   350,   445,   351,   347,
     347,   447,   528,   447,   448,   513,   351,   350,   447,   448,
     350,   347,   351,   351,   342,   528,   528,   528,   528,   337,
     337,   337,   335,   335,   335,   335,   335,   335,   335,   342,
     342,   342,   350,   518,   483,   342,   342,   342,   320,   321,
     322,   487,   487,   488,   335,   337,   337,   338,   335,   335,
     335,   513,   451,   513,   513,   351,   335,   336,   450,   513,
     513,   351,   351,   518,   335,   513,   351,   349,   536,   536,
     335,   335,   536,   357,   357,   357,   357,   526,   525,   527,
     534,   524,   438,   437,   438,   521,   352,   349,   349,   488,
     335,   349,   487,   487,   487,   342,   486,   486,   486,   518,
     354,   364,   536,   521,   521,   518,   446,   351,   446,   446,
     335,   513,   513,   347,   348,   449,   335,   335,   335,   448,
     446,   335,   350,   351,   521,   534,   518,   335,   335,   335,
     518,   518,   518,   351,   349,   350,   518,   521,   518,   318,
     350,   335,   335,   335,   335,   351,   335,   351,   351,   513,
     335,   528,   488,   348,   513,   513,   349,   351,   513,   534,
     459,   335,   335,   335,   527,   438,   440,   521,   437,   438,
     521,   335,   335,   335,   350,   488,   335,   335,   335,   326,
       6,   521,   521,   518,   335,   534,   335,   335,   335,   534,
     337,   536,   335,   335,   350,   335,   335,   351,   335,   448,
     448,   508,   524,   533,   335,   352,   349,   513,   488,   351,
     488,   488,   488,   351,   338,   335,   335,   534,   534,   534,
     534,   348,   528,   534,   534,   534,   534,   534,   335,   534,
     438,   440,   350,   350,   335,   351,   335,   335,   335,   536,
     521,   521,   348,   348,   351,   513,   488,   488,   513,   335,
     513,   488,   488,   335,   536,   348,   335,   335,   351,   351,
     513,   335,     6,   536,   513,   513,   335,   335,   335,   488,
     338,   335,   335,   513,   513,   513,   335,   536,   513,   513,
     335,   513,   335,   513,     6,   335,   338,   513,   536
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   359,   361,   360,   362,   362,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   364,   364,
     364,   364,   365,   366,   367,   367,   369,   368,   370,   371,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   379,
     379,   379,   379,   379,   379,   380,   380,   381,   381,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   383,
     384,   384,   385,   385,   386,   386,   387,   388,   387,   389,
     387,   390,   387,   391,   387,   392,   387,   393,   387,   394,
     387,   395,   387,   396,   387,   387,   397,   387,   387,   387,
     387,   387,   387,   387,   398,   387,   387,   387,   387,   387,
     399,   387,   387,   400,   387,   387,   401,   387,   402,   387,
     387,   403,   387,   404,   404,   405,   405,   407,   406,   409,
     408,   411,   410,   413,   412,   415,   414,   417,   416,   418,
     418,   418,   418,   418,   418,   418,   418,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   420,   420,   420,   420,   420,   420,   421,   421,   421,
     421,   421,   421,   421,   421,   421,   421,   421,   421,   421,
     421,   421,   421,   421,   421,   421,   421,   421,   421,   421,
     421,   421,   421,   421,   422,   422,   422,   422,   422,   422,
     423,   423,   423,   424,   424,   425,   425,   426,   426,   426,
     426,   426,   426,   426,   426,   426,   426,   426,   426,   426,
     426,   426,   426,   427,   427,   427,   427,   427,   428,   428,
     429,   429,   430,   430,   430,   430,   431,   431,   431,   431,
     431,   431,   431,   431,   431,   431,   432,   433,   433,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     436,   436,   437,   438,   439,   440,   441,   441,   441,   441,
     441,   441,   441,   441,   441,   441,   441,   441,   441,   441,
     441,   441,   441,   442,   442,   443,   443,   443,   443,   444,
     445,   446,   446,   447,   447,   448,   449,   449,   450,   450,
     451,   453,   452,   454,   452,   455,   452,   456,   452,   457,
     452,   458,   459,   452,   461,   460,   462,   460,   463,   460,
     464,   460,   465,   460,   467,   466,   469,   468,   471,   470,
     472,   472,   472,   472,   472,   472,   472,   472,   472,   472,
     472,   473,   473,   473,   473,   473,   473,   473,   473,   473,
     473,   473,   474,   474,   474,   474,   474,   474,   474,   474,
     474,   474,   474,   475,   476,   477,   478,   478,   478,   479,
     480,   481,   482,   482,   483,   482,   484,   484,   484,   485,
     486,   486,   487,   487,   487,   488,   488,   489,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     491,   492,   492,   492,   493,   494,   494,   495,   496,   496,
     496,   498,   497,   499,   497,   500,   500,   500,   501,   501,
     501,   501,   501,   501,   501,   501,   501,   501,   501,   501,
     502,   502,   502,   502,   503,   503,   505,   504,   506,   504,
     507,   507,   507,   508,   508,   509,   509,   509,   510,   510,
     510,   510,   510,   510,   511,   510,   512,   513,   513,   513,
     513,   514,   514,   514,   514,   515,   516,   516,   516,   516,
     516,   517,   517,   518,   518,   519,   519,   519,   519,   519,
     520,   520,   521,   521,   522,   522,   523,   523,   524,   524,
     525,   525,   525,   526,   526,   526,   527,   527,   527,   528,
     528,   528,   529,   529,   530,   530,   531,   531,   532,   532,
     533,   533,   533,   533,   533,   533,   533,   534,   534,   534,
     534,   534,   535,   535,   535,   535,   535,   535,   535,   535,
     535,   535,   535,   535,   536,   536,   536,   536,   537,   537,
     538,   538,   538,   538,   538,   538,   538,   538
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     6,    11,     3,     0,     0,     4,     4,     4,
       4,     4,     2,     2,     1,    10,    10,    23,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     2,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     2,
       2,     1,     2,     1,     2,     2,     1,     0,     5,     0,
       7,     0,     7,     0,     5,     0,     5,     0,     5,     0,
       3,     0,     3,     0,     3,     1,     0,     3,     1,     1,
       1,     1,     1,     1,     0,     3,     1,     1,     1,     1,
       0,     3,     1,     0,     3,     1,     0,     3,     0,     3,
       1,     0,     5,     3,     3,     1,     1,     0,     5,     0,
       5,     0,     5,     0,    11,     0,    13,     0,    13,     1,
       1,     1,     1,     1,     1,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     8,     6,     2,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     8,     8,     8,    10,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       0,     2,     1,     1,     3,     1,     5,    10,    12,    12,
      10,    10,     8,    10,    10,     8,     8,     6,     8,     6,
       6,     4,     1,     2,     2,     2,     2,     2,     2,     2,
       1,     1,     2,     1,     2,     1,     7,     2,     7,     2,
       3,     0,    12,     0,    11,     0,    12,     0,    12,     0,
      12,     0,     0,    12,     0,    12,     0,    11,     0,    12,
       0,    12,     0,    12,     0,    17,     0,    17,     0,     9,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,    20,    13,    16,     1,     1,     1,     1,
       1,     1,     9,    16,     0,    17,     1,     1,     1,     3,
       0,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,    11,    13,    13,     1,     6,     9,     7,     1,     1,
       3,     0,    11,     0,    11,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     0,     2,     0,     3,     0,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,    11,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     1,     1,     2,     1,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     0,
       2,     2,     5,     5,     5,     5,     5,     5,     1,     1,
       1,     3,     3,     4,     4,     3,     3,     1,     3,     1,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 708 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 3123 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 18: /* const_val: T_FLOAT  */
#line 726 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 3129 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: T_INT  */
#line 727 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 3135 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* const_val: '-' T_INT  */
#line 728 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 3141 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* const_val: T_HEX  */
#line 729 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 3147 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 22: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 731 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 3157 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 737 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 3165 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 24: /* buf_header_addr_reg: '(' T_CONSTANT ')'  */
#line 742 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3178 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 26: /* $@2: %empty  */
#line 752 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 3188 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 28: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 758 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 3198 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 29: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 764 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen >= 5);
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 3210 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 30: /* wgid_header: T_A_WGID '(' T_CONSTANT ')'  */
#line 771 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen < 5);
                       info->wgid = reg;
}
#line 3221 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 31: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 778 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       if (variant->compiler->gen >= 5)
                          add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3234 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 32: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 787 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 3240 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* pvtmem_header: T_A_PVTMEM const_val  */
#line 789 "../src/freedreno/ir3/ir3_parser.y"
                                    { variant->pvtmem_size = (yyvsp[0].unum); }
#line 3246 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* earlypreamble_header: T_A_EARLYPREAMBLE  */
#line 791 "../src/freedreno/ir3/ir3_parser.y"
                                        { info->early_preamble = 1; }
#line 3252 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 794 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 3258 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 796 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 3264 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 37: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 803 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 3270 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 38: /* iflag: T_SY  */
#line 805 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 3276 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 39: /* iflag: T_SS  */
#line 806 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 3282 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 40: /* iflag: T_JP  */
#line 807 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 3288 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 41: /* iflag: T_SAT  */
#line 808 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 3294 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 42: /* iflag: T_RPT  */
#line 809 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 3300 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 43: /* iflag: T_UL  */
#line 810 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 3306 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 44: /* iflag: T_NOP  */
#line 811 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 3312 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 54: /* instr: iflags cat5_instr  */
#line 824 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 3318 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 59: /* label: T_IDENTIFIER ':'  */
#line 830 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 3324 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 60: /* cat0_src1: '!' T_P0  */
#line 832 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3330 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 61: /* cat0_src1: T_P0  */
#line 833 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3336 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 62: /* cat0_src2: '!' T_P0  */
#line 835 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3342 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 63: /* cat0_src2: T_P0  */
#line 836 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3348 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 64: /* cat0_immed: '#' integer  */
#line 838 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 3354 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 65: /* cat0_immed: '#' T_IDENTIFIER  */
#line 839 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3360 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 66: /* cat0_instr: T_OP_NOP  */
#line 841 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 3366 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 67: /* $@3: %empty  */
#line 842 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_PLAIN; }
#line 3372 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 69: /* $@4: %empty  */
#line 843 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_OR;    }
#line 3378 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 71: /* $@5: %empty  */
#line 844 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_AND;    }
#line 3384 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 73: /* $@6: %empty  */
#line 845 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_B)->cat0.brtype = BRANCH_CONST; instr->cat0.idx = (yyvsp[0].num); }
#line 3390 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 75: /* $@7: %empty  */
#line 846 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ANY; }
#line 3396 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 77: /* $@8: %empty  */
#line 847 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ALL; }
#line 3402 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 79: /* $@9: %empty  */
#line 848 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_X; }
#line 3408 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 81: /* $@10: %empty  */
#line 849 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3414 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 83: /* $@11: %empty  */
#line 850 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3420 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 85: /* cat0_instr: T_OP_RET  */
#line 851 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3426 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 86: /* $@12: %empty  */
#line 852 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3432 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 88: /* cat0_instr: T_OP_END  */
#line 853 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3438 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 89: /* cat0_instr: T_OP_EMIT  */
#line 854 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3444 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 90: /* cat0_instr: T_OP_CUT  */
#line 855 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3450 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* cat0_instr: T_OP_CHMASK  */
#line 856 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3456 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 92: /* cat0_instr: T_OP_CHSH  */
#line 857 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3462 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 93: /* cat0_instr: T_OP_FLOW_REV  */
#line 858 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3468 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 94: /* $@13: %empty  */
#line 859 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3474 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 96: /* cat0_instr: T_OP_STKS  */
#line 860 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3480 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 97: /* cat0_instr: T_OP_STKR  */
#line 861 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3486 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 98: /* cat0_instr: T_OP_XSET  */
#line 862 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3492 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* cat0_instr: T_OP_XCLR  */
#line 863 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3498 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 100: /* $@14: %empty  */
#line 864 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3504 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 102: /* cat0_instr: T_OP_DBG  */
#line 865 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3510 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 103: /* $@15: %empty  */
#line 866 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3516 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 105: /* cat0_instr: T_OP_SHPE  */
#line 867 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3522 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 106: /* $@16: %empty  */
#line 868 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3528 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 108: /* $@17: %empty  */
#line 869 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3534 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 110: /* cat0_instr: T_OP_PREDE  */
#line 870 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3540 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 111: /* $@18: %empty  */
#line 871 "../src/freedreno/ir3/ir3_parser.y"
                                        { new_instr(OPC_GETLAST); }
#line 3546 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 113: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 873 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3554 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 114: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 876 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3562 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 117: /* $@19: %empty  */
#line 883 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                   }
#line 3572 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 118: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@19 dst_reg  */
#line 887 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       if (((yyvsp[-2].num) % 32) != 0)
                          yyerror("w# must be multiple of 32");
                       if ((yyvsp[-2].num) < 32)
                          yyerror("w# must be at least 32");

                       int num = (yyvsp[-2].num) / 32;

                       instr->repeat = num - 1;
                       instr->dsts[0]->wrmask = (1 << num) - 1;
                   }
#line 3588 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 119: /* $@20: %empty  */
#line 899 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3599 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 121: /* $@21: %empty  */
#line 906 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3610 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 123: /* $@22: %empty  */
#line 913 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3616 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 125: /* $@23: %empty  */
#line 915 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3622 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 127: /* $@24: %empty  */
#line 917 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3628 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 137: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 929 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3634 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 138: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 930 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3640 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 139: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 931 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3646 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 140: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 932 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3652 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 141: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 933 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3658 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 142: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 934 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3664 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 143: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 935 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3670 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 936 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3676 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 145: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 937 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3682 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 146: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 938 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3688 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 147: /* cat2_opc_1src: T_OP_NOT_B  */
#line 939 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3694 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 148: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 940 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3700 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 149: /* cat2_opc_1src: T_OP_SETRM  */
#line 941 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3706 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 150: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 942 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3712 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 151: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 944 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3718 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 152: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 945 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3724 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 153: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 946 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 3730 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 947 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 3736 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 948 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 3742 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 949 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 3748 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_2src: T_OP_ADD_F  */
#line 951 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 3754 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_2src: T_OP_MIN_F  */
#line 952 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 3760 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_2src: T_OP_MAX_F  */
#line 953 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 3766 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_2src: T_OP_MUL_F  */
#line 954 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 3772 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_2src: T_OP_ADD_U  */
#line 955 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 3778 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_2src: T_OP_ADD_S  */
#line 956 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 3784 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cat2_opc_2src: T_OP_SUB_U  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 3790 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cat2_opc_2src: T_OP_SUB_S  */
#line 958 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 3796 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cat2_opc_2src: T_OP_MIN_U  */
#line 959 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 3802 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cat2_opc_2src: T_OP_MIN_S  */
#line 960 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 3808 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cat2_opc_2src: T_OP_MAX_U  */
#line 961 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 3814 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cat2_opc_2src: T_OP_MAX_S  */
#line 962 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 3820 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 169: /* cat2_opc_2src: T_OP_AND_B  */
#line 963 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 3826 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 170: /* cat2_opc_2src: T_OP_OR_B  */
#line 964 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 3832 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 171: /* cat2_opc_2src: T_OP_XOR_B  */
#line 965 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 3838 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 966 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 3844 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 967 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 3850 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat2_opc_2src: T_OP_MULL_U  */
#line 968 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 3856 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cat2_opc_2src: T_OP_SHL_B  */
#line 969 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 3862 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cat2_opc_2src: T_OP_SHR_B  */
#line 970 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 3868 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 971 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 3874 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cat2_opc_2src: T_OP_BARY_F  */
#line 972 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 3880 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cat2_opc_2src: T_OP_FLAT_B  */
#line 973 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLAT_B); }
#line 3886 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 974 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 3892 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 181: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 975 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 3898 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 182: /* cat2_opc_2src: T_OP_SHB  */
#line 976 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 3904 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 183: /* cat2_opc_2src: T_OP_MSAD  */
#line 977 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 3910 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 184: /* cond: T_LT  */
#line 979 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 3916 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 185: /* cond: T_LE  */
#line 980 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 3922 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 186: /* cond: T_GT  */
#line 981 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 3928 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cond: T_GE  */
#line 982 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 3934 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 188: /* cond: T_EQ  */
#line 983 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 3940 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cond: T_NE  */
#line 984 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 3946 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 193: /* cat3_dp_signedness: '.' T_MIXED  */
#line 990 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_MIXED; }
#line 3952 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 194: /* cat3_dp_signedness: '.' T_UNSIGNED  */
#line 991 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_UNSIGNED; }
#line 3958 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cat3_dp_pack: '.' T_LOW  */
#line 993 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_LOW; }
#line 3964 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cat3_dp_pack: '.' T_HIGH  */
#line 994 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_HIGH; }
#line 3970 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 197: /* cat3_opc: T_OP_MAD_U16  */
#line 996 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 3976 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 198: /* cat3_opc: T_OP_MADSH_U16  */
#line 997 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 3982 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 199: /* cat3_opc: T_OP_MAD_S16  */
#line 998 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 3988 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 200: /* cat3_opc: T_OP_MADSH_M16  */
#line 999 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 3994 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* cat3_opc: T_OP_MAD_U24  */
#line 1000 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 4000 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 202: /* cat3_opc: T_OP_MAD_S24  */
#line 1001 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 4006 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 203: /* cat3_opc: T_OP_MAD_F16  */
#line 1002 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 4012 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* cat3_opc: T_OP_MAD_F32  */
#line 1003 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 4018 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 205: /* cat3_opc: T_OP_SEL_B16  */
#line 1004 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 4024 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cat3_opc: T_OP_SEL_B32  */
#line 1005 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 4030 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 207: /* cat3_opc: T_OP_SEL_S16  */
#line 1006 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 4036 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 208: /* cat3_opc: T_OP_SEL_S32  */
#line 1007 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 4042 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 209: /* cat3_opc: T_OP_SEL_F16  */
#line 1008 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 4048 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat3_opc: T_OP_SEL_F32  */
#line 1009 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 4054 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat3_opc: T_OP_SAD_S16  */
#line 1010 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 4060 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat3_opc: T_OP_SAD_S32  */
#line 1011 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 4066 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 213: /* cat3_imm_reg_opc: T_OP_SHRM  */
#line 1013 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRM); }
#line 4072 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat3_imm_reg_opc: T_OP_SHLM  */
#line 1014 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLM); }
#line 4078 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat3_imm_reg_opc: T_OP_SHRG  */
#line 1015 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRG); }
#line 4084 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 216: /* cat3_imm_reg_opc: T_OP_SHLG  */
#line 1016 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLG); }
#line 4090 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat3_imm_reg_opc: T_OP_ANDG  */
#line 1017 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ANDG); }
#line 4096 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat3_wmm: T_OP_WMM  */
#line 1019 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM); }
#line 4102 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat3_wmm: T_OP_WMM_ACCU  */
#line 1020 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM_ACCU); }
#line 4108 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat3_dp: T_OP_DP2ACC  */
#line 1022 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP2ACC); }
#line 4114 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat3_dp: T_OP_DP4ACC  */
#line 1023 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP4ACC); }
#line 4120 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 226: /* cat4_opc: T_OP_RCP  */
#line 1030 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 4126 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 227: /* cat4_opc: T_OP_RSQ  */
#line 1031 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 4132 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat4_opc: T_OP_LOG2  */
#line 1032 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 4138 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 229: /* cat4_opc: T_OP_EXP2  */
#line 1033 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 4144 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 230: /* cat4_opc: T_OP_SIN  */
#line 1034 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 4150 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 231: /* cat4_opc: T_OP_COS  */
#line 1035 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 4156 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 232: /* cat4_opc: T_OP_SQRT  */
#line 1036 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 4162 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat4_opc: T_OP_HRSQ  */
#line 1037 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 4168 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat4_opc: T_OP_HLOG2  */
#line 1038 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 4174 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat4_opc: T_OP_HEXP2  */
#line 1039 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 4180 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 237: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 1043 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 4186 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 238: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 1044 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 4192 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 239: /* cat5_opc: T_OP_ISAM  */
#line 1046 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM); }
#line 4198 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 240: /* cat5_opc: T_OP_ISAML  */
#line 1047 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 4204 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 241: /* cat5_opc: T_OP_ISAMM  */
#line 1048 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 4210 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 242: /* cat5_opc: T_OP_SAM  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 4216 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 243: /* cat5_opc: T_OP_SAMB  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 4222 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 244: /* cat5_opc: T_OP_SAML  */
#line 1051 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 4228 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 245: /* cat5_opc: T_OP_SAMGQ  */
#line 1052 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 4234 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 246: /* cat5_opc: T_OP_GETLOD  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 4240 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 247: /* cat5_opc: T_OP_CONV  */
#line 1054 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 4246 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 248: /* cat5_opc: T_OP_CONVM  */
#line 1055 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 4252 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 249: /* cat5_opc: T_OP_GETSIZE  */
#line 1056 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 4258 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 250: /* cat5_opc: T_OP_GETBUF  */
#line 1057 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 4264 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 251: /* cat5_opc: T_OP_GETPOS  */
#line 1058 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 4270 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 252: /* cat5_opc: T_OP_GETINFO  */
#line 1059 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 4276 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 253: /* cat5_opc: T_OP_DSX  */
#line 1060 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 4282 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 254: /* cat5_opc: T_OP_DSY  */
#line 1061 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 4288 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 255: /* cat5_opc: T_OP_GATHER4R  */
#line 1062 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 4294 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 256: /* cat5_opc: T_OP_GATHER4G  */
#line 1063 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 4300 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 257: /* cat5_opc: T_OP_GATHER4B  */
#line 1064 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 4306 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 258: /* cat5_opc: T_OP_GATHER4A  */
#line 1065 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 4312 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 259: /* cat5_opc: T_OP_SAMGP0  */
#line 1066 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 4318 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 260: /* cat5_opc: T_OP_SAMGP1  */
#line 1067 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 4324 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 261: /* cat5_opc: T_OP_SAMGP2  */
#line 1068 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 4330 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 262: /* cat5_opc: T_OP_SAMGP3  */
#line 1069 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 4336 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 263: /* cat5_opc: T_OP_RGETPOS  */
#line 1070 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 4342 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 264: /* cat5_opc: T_OP_RGETINFO  */
#line 1071 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 4348 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 265: /* cat5_opc: T_OP_BRCST_A  */
#line 1072 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BRCST_ACTIVE); }
#line 4354 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 266: /* cat5_opc: T_OP_QSHUFFLE_BRCST  */
#line 1073 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_BRCST); }
#line 4360 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 267: /* cat5_opc: T_OP_QSHUFFLE_H  */
#line 1074 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_HORIZ); }
#line 4366 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 268: /* cat5_opc: T_OP_QSHUFFLE_V  */
#line 1075 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_VERT); }
#line 4372 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 269: /* cat5_opc: T_OP_QSHUFFLE_DIAG  */
#line 1076 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_DIAG); }
#line 4378 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 270: /* cat5_flag: '.' T_3D  */
#line 1078 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 4384 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 271: /* cat5_flag: '.' 'a'  */
#line 1079 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 4390 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 272: /* cat5_flag: '.' 'o'  */
#line 1080 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 4396 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 273: /* cat5_flag: '.' 'p'  */
#line 1081 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 4402 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 274: /* cat5_flag: '.' 's'  */
#line 1082 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 4408 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* cat5_flag: '.' T_S2EN  */
#line 1083 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 4414 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 276: /* cat5_flag: '.' T_UNIFORM  */
#line 1084 "../src/freedreno/ir3/ir3_parser.y"
                                  { }
#line 4420 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* cat5_flag: '.' T_NONUNIFORM  */
#line 1085 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4426 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* cat5_flag: '.' T_BASE  */
#line 1086 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4432 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 279: /* cat5_flag: '.' T_W  */
#line 1087 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.cluster_size = (yyvsp[0].num); }
#line 4438 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 282: /* cat5_samp: T_SAMP  */
#line 1091 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 4444 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 283: /* cat5_tex: T_TEX  */
#line 1092 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.tex = (yyvsp[0].tok); }
#line 4450 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* cat5_type: '(' type ')'  */
#line 1093 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 4456 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 285: /* cat5_a1: src_reg  */
#line 1094 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 4462 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 302: /* cat5_instr: T_OP_TCINV  */
#line 1112 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_TCINV); }
#line 4468 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 303: /* cat6_typed: '.' T_UNTYPED  */
#line 1114 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 4474 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 304: /* cat6_typed: '.' T_TYPED  */
#line 1115 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 4480 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 305: /* cat6_dim: '.' T_1D  */
#line 1117 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 4486 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 306: /* cat6_dim: '.' T_2D  */
#line 1118 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 4492 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 307: /* cat6_dim: '.' T_3D  */
#line 1119 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 4498 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 308: /* cat6_dim: '.' T_4D  */
#line 1120 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 4504 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 309: /* cat6_type: '.' type  */
#line 1122 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 4510 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 310: /* cat6_imm_offset: offset  */
#line 1123 "../src/freedreno/ir3/ir3_parser.y"
                             { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4516 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 313: /* cat6_dst_offset: offset  */
#line 1126 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4522 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 315: /* cat6_immed: integer  */
#line 1129 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4528 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 316: /* cat6_a6xx_global_address_pt3: '<' '<' integer offset '<' '<' integer  */
#line 1132 "../src/freedreno/ir3/ir3_parser.y"
                                                          {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 4538 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 318: /* cat6_a6xx_global_address_pt2: '(' src offset ')' '<' '<' integer  */
#line 1140 "../src/freedreno/ir3/ir3_parser.y"
                                                      {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                   }
#line 4548 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 321: /* $@25: %empty  */
#line 1151 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG); }
#line 4554 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 323: /* $@26: %empty  */
#line 1152 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_A); }
#line 4560 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 325: /* $@27: %empty  */
#line 1153 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDP); }
#line 4566 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 327: /* $@28: %empty  */
#line 1154 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDL); }
#line 4572 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 329: /* $@29: %empty  */
#line 1155 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLW); }
#line 4578 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 331: /* $@30: %empty  */
#line 1156 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLV); }
#line 4584 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 332: /* $@31: %empty  */
#line 1156 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4592 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 334: /* $@32: %empty  */
#line 1160 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG); dummy_dst(); }
#line 4598 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 336: /* $@33: %empty  */
#line 1161 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG_A); dummy_dst(); }
#line 4604 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 338: /* $@34: %empty  */
#line 1162 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4610 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 340: /* $@35: %empty  */
#line 1163 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4616 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 342: /* $@36: %empty  */
#line 1164 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4622 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 344: /* $@37: %empty  */
#line 1166 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDIB); }
#line 4628 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 346: /* $@38: %empty  */
#line 1167 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4634 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 348: /* $@39: %empty  */
#line 1169 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4640 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 350: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 1171 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4646 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 351: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 1172 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4652 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 352: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 1173 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4658 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 353: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1174 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4664 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 354: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1175 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4670 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 355: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1176 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4676 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 356: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1177 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4682 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 357: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1178 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4688 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 358: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1179 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4694 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 359: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1180 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 4700 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 360: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1181 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 4706 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 361: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_ADD  */
#line 1183 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_ADD); }
#line 4712 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 362: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_SUB  */
#line 1184 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_SUB); }
#line 4718 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 363: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XCHG  */
#line 1185 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XCHG); }
#line 4724 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 364: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_INC  */
#line 1186 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_INC); }
#line 4730 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 365: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_DEC  */
#line 1187 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_DEC); }
#line 4736 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_CMPXCHG  */
#line 1188 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_CMPXCHG); }
#line 4742 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 367: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MIN  */
#line 1189 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MIN); }
#line 4748 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 368: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MAX  */
#line 1190 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MAX); }
#line 4754 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 369: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_AND  */
#line 1191 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_AND); }
#line 4760 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 370: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_OR  */
#line 1192 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_OR); }
#line 4766 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 371: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XOR  */
#line 1193 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XOR); }
#line 4772 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 372: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_ADD  */
#line 1195 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_ADD); }
#line 4778 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 373: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_SUB  */
#line 1196 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_SUB); }
#line 4784 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 374: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XCHG  */
#line 1197 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XCHG); }
#line 4790 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 375: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_INC  */
#line 1198 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_INC); }
#line 4796 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 376: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_DEC  */
#line 1199 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_DEC); }
#line 4802 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 377: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_CMPXCHG  */
#line 1200 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_CMPXCHG); }
#line 4808 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 378: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MIN  */
#line 1201 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MIN); }
#line 4814 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 379: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MAX  */
#line 1202 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MAX); }
#line 4820 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 380: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_AND  */
#line 1203 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_AND); }
#line 4826 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 381: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_OR  */
#line 1204 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_OR); }
#line 4832 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 382: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XOR  */
#line 1205 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XOR); }
#line 4838 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 389: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1217 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 4844 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 390: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1219 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 4850 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 391: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1220 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 4856 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 394: /* $@40: %empty  */
#line 1224 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 4862 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 396: /* cat6_id_opc: T_OP_GETSPID  */
#line 1227 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 4868 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 397: /* cat6_id_opc: T_OP_GETWID  */
#line 1228 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 4874 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* cat6_id_opc: T_OP_GETFIBERID  */
#line 1229 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETFIBERID); }
#line 4880 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 401: /* cat6_bindless_base: '.' T_BASE  */
#line 1234 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 4886 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 404: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1238 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4892 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 406: /* cat6_reg_or_immed: integer  */
#line 1241 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4898 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 407: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1243 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 4904 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 408: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1245 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_B_ADD); dummy_dst(); }
#line 4910 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 409: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1246 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_SUB); dummy_dst(); }
#line 4916 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 410: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1247 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XCHG); dummy_dst(); }
#line 4922 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 411: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1248 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_INC); dummy_dst(); }
#line 4928 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 412: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1249 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_DEC); dummy_dst(); }
#line 4934 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 413: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1250 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_CMPXCHG); dummy_dst(); }
#line 4940 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 414: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1251 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MIN); dummy_dst(); }
#line 4946 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 415: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1252 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MAX); dummy_dst(); }
#line 4952 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 416: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1253 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_AND); dummy_dst(); }
#line 4958 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 417: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1254 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_OR); dummy_dst(); }
#line 4964 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 418: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1255 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XOR); dummy_dst(); }
#line 4970 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 419: /* cat6_bindless_ibo_opc_2src: T_OP_STIB_B  */
#line 1256 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 4976 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 420: /* cat6_bindless_ibo_opc_2src_dst: T_OP_LDIB_B  */
#line 1258 "../src/freedreno/ir3/ir3_parser.y"
                                                         { new_instr(OPC_LDIB); }
#line 4982 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 422: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1261 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); }
#line 4988 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 423: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src_dst cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1262 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                          { swap(instr->srcs[0], instr->srcs[1]); }
#line 4994 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 424: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1264 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 5000 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 425: /* cat6_bindless_ldc_middle: T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1268 "../src/freedreno/ir3/ir3_parser.y"
                                                                               { instr->cat6.d = (yyvsp[-5].tok); }
#line 5006 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 426: /* cat6_bindless_ldc_middle: cat6_immed '.' 'k' '.' cat6_bindless_mode 'c' '[' T_A1 ']'  */
#line 1269 "../src/freedreno/ir3/ir3_parser.y"
                                                                                   { instr->opc = OPC_LDC_K; }
#line 5012 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 427: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' cat6_bindless_ldc_middle ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1271 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                  {
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 5022 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 428: /* stc_dst: integer  */
#line 1277 "../src/freedreno/ir3/ir3_parser.y"
                          { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5028 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 429: /* stc_dst: T_A1  */
#line 1278 "../src/freedreno/ir3/ir3_parser.y"
                       { new_src(0, IR3_REG_IMMED)->iim_val = 0; instr->flags |= IR3_INSTR_A1EN; }
#line 5034 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 430: /* stc_dst: T_A1 '+' integer  */
#line 1279 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); instr->flags |= IR3_INSTR_A1EN; }
#line 5040 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 431: /* $@41: %empty  */
#line 1282 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STC); }
#line 5046 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 433: /* $@42: %empty  */
#line 1283 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STSC); }
#line 5052 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 435: /* cat6_todo: T_OP_G2L  */
#line 1285 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 5058 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 436: /* cat6_todo: T_OP_L2G  */
#line 1286 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 5064 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 437: /* cat6_todo: T_OP_RESFMT  */
#line 1287 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 5070 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 450: /* cat7_scope: '.' 'w'  */
#line 1302 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 5076 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 451: /* cat7_scope: '.' 'r'  */
#line 1303 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 5082 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 452: /* cat7_scope: '.' 'l'  */
#line 1304 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 5088 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 453: /* cat7_scope: '.' 'g'  */
#line 1305 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 5094 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 456: /* $@43: %empty  */
#line 1310 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 5100 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 458: /* $@44: %empty  */
#line 1311 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 5106 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 460: /* cat7_data_cache: T_OP_DCCLN  */
#line 1313 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCCLN); }
#line 5112 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 461: /* cat7_data_cache: T_OP_DCINV  */
#line 1314 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCINV); }
#line 5118 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 462: /* cat7_data_cache: T_OP_DCFLU  */
#line 1315 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCFLU); }
#line 5124 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 465: /* cat7_alias_scope: T_MOD_TEX  */
#line 1320 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_TEX; }
#line 5130 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 466: /* cat7_alias_scope: T_MOD_MEM  */
#line 1321 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_MEM; }
#line 5136 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 467: /* cat7_alias_scope: T_MOD_RT  */
#line 1322 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_RT; }
#line 5142 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 470: /* cat7_instr: T_OP_SLEEP  */
#line 1326 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_SLEEP); }
#line 5148 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 471: /* cat7_instr: T_OP_ICINV  */
#line 1327 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_ICINV); }
#line 5154 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 472: /* cat7_instr: T_OP_LOCK  */
#line 1328 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_LOCK); }
#line 5160 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 473: /* cat7_instr: T_OP_UNLOCK  */
#line 1329 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_UNLOCK); }
#line 5166 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 474: /* $@45: %empty  */
#line 1330 "../src/freedreno/ir3/ir3_parser.y"
                              {
                       /* TODO: handle T_INSTR_TYPE */
                       new_instr(OPC_ALIAS);
                   }
#line 5175 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 475: /* cat7_instr: T_OP_ALIAS $@45 '.' cat7_alias_scope '.' T_INSTR_TYPE '.' integer dst_reg ',' cat7_alias_src  */
#line 1333 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 5183 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 476: /* raw_instr: T_RAW  */
#line 1337 "../src/freedreno/ir3/ir3_parser.y"
                   {new_instr(OPC_META_RAW)->raw.value = (yyvsp[0].u64);}
#line 5189 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 477: /* src: T_REGISTER  */
#line 1339 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 5195 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 478: /* src: T_A0  */
#line 1340 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 5201 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 479: /* src: T_A1  */
#line 1341 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 5207 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 480: /* src: T_P0  */
#line 1342 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), 0); }
#line 5213 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 481: /* dst: T_REGISTER  */
#line 1344 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 5219 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 482: /* dst: T_A0  */
#line 1345 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 5225 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 483: /* dst: T_A1  */
#line 1346 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 5231 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 484: /* dst: T_P0  */
#line 1347 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), 0); }
#line 5237 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 485: /* const: T_CONSTANT  */
#line 1349 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 5243 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 486: /* dst_reg_flag: T_EVEN  */
#line 1351 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_EVEN; }
#line 5249 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 487: /* dst_reg_flag: T_POS_INFINITY  */
#line 1352 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_POS_INF; }
#line 5255 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 488: /* dst_reg_flag: T_NEG_INFINITY  */
#line 1353 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_NEG_INF; }
#line 5261 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 489: /* dst_reg_flag: T_EI  */
#line 1354 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 5267 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 490: /* dst_reg_flag: T_WRMASK  */
#line 1355 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 5273 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 493: /* dst_reg: dst  */
#line 1361 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5279 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 494: /* dst_reg: dst_reg_flags dst  */
#line 1362 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5285 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 495: /* src_reg_flag: T_ABSNEG  */
#line 1364 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 5291 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 496: /* src_reg_flag: T_NEG  */
#line 1365 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 5297 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 497: /* src_reg_flag: T_ABS  */
#line 1366 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 5303 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 498: /* src_reg_flag: T_R  */
#line 1367 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 5309 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 499: /* src_reg_flag: T_LAST  */
#line 1368 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_LAST_USE; }
#line 5315 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 519: /* offset: %empty  */
#line 1397 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 5321 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 520: /* offset: '+' integer  */
#line 1398 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5327 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 521: /* offset: '-' integer  */
#line 1399 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5333 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 522: /* relative_gpr_src: 'r' '<' T_A0 offset '>'  */
#line 1401 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5339 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 523: /* relative_gpr_src: T_HR '<' T_A0 offset '>'  */
#line 1402 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5345 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 524: /* relative_gpr_dst: 'r' '<' T_A0 offset '>'  */
#line 1404 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5351 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 525: /* relative_gpr_dst: T_HR '<' T_A0 offset '>'  */
#line 1405 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5357 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 526: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1407 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 5363 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 527: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1408 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5369 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 530: /* immediate_cat1: integer  */
#line 1417 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 5375 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 531: /* immediate_cat1: '(' integer ')'  */
#line 1418 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5381 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 532: /* immediate_cat1: '(' float ')'  */
#line 1419 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 5387 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 533: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1420 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 5393 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 534: /* immediate_cat1: 'h' '(' float ')'  */
#line 1421 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 5399 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 535: /* immediate_cat1: '(' T_NAN ')'  */
#line 1422 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 5405 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 536: /* immediate_cat1: '(' T_INF ')'  */
#line 1423 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 5411 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 537: /* immediate: integer  */
#line 1425 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5417 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 538: /* immediate: '(' integer ')'  */
#line 1426 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5423 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 539: /* immediate: flut_immed  */
#line 1427 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 5429 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 540: /* immediate: 'h' '(' integer ')'  */
#line 1428 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 5435 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 541: /* immediate: 'h' flut_immed  */
#line 1429 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 5441 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 554: /* integer: T_INT  */
#line 1445 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5447 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 555: /* integer: '-' T_INT  */
#line 1446 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5453 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 556: /* integer: T_HEX  */
#line 1447 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 5459 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 557: /* integer: '-' T_HEX  */
#line 1448 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 5465 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 558: /* float: T_FLOAT  */
#line 1450 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 5471 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 559: /* float: '-' T_FLOAT  */
#line 1451 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 5477 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 560: /* type: T_TYPE_F16  */
#line 1453 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F16; }
#line 5483 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 561: /* type: T_TYPE_F32  */
#line 1454 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F32; }
#line 5489 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 562: /* type: T_TYPE_U16  */
#line 1455 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U16; }
#line 5495 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 563: /* type: T_TYPE_U32  */
#line 1456 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U32; }
#line 5501 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 564: /* type: T_TYPE_S16  */
#line 1457 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S16; }
#line 5507 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 565: /* type: T_TYPE_S32  */
#line 1458 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S32; }
#line 5513 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 566: /* type: T_TYPE_U8  */
#line 1459 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U8;  }
#line 5519 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 567: /* type: T_TYPE_S8  */
#line 1460 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S8;  }
#line 5525 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 5529 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

